###Creation of new variables######################################
ALTER TABLE `siscolo`.`citologico` 
ADD COLUMN `atipias_l` VARCHAR(1) NULL AFTER `id_u_coleta`,
ADD COLUMN `atipias_h` VARCHAR(1) NULL AFTER `atipias_l`,
ADD COLUMN `cancers` VARCHAR(1) NULL AFTER `atipias_h`,
ADD COLUMN `alt_ben` VARCHAR(1) NULL AFTER `cancers`,
ADD COLUMN `res_nao_alt` VARCHAR(1) NULL AFTER `alt_ben`,
ADD COLUMN `nics_cancers` VARCHAR(1) NULL AFTER `res_nao_alt`,
ADD COLUMN `nic2_nic3` VARCHAR(1) NULL AFTER `nics_cancers`,
ADD COLUMN `laminas_rejs` VARCHAR(1) NULL AFTER `nic2_nic3`,
ADD COLUMN `laminas_insat` VARCHAR(1) NULL AFTER `laminas_rejs`,
ADD COLUMN `laminas_sat` VARCHAR(1) NULL AFTER `laminas_insat`,
ADD COLUMN `zt` VARCHAR(1) NULL AFTER `laminas_sat`,
ADD COLUMN `ascus_asch` VARCHAR(1) NULL AFTER `zt`,
ADD COLUMN `lsil_hsil` VARCHAR(1) NULL AFTER `ascus_asch`,
ADD COLUMN `res_alterados` VARCHAR(1) NULL AFTER `lsil_hsil`,
ADD COLUMN `exames_por_ano` INT NULL AFTER `res_alterados`,
ADD COLUMN `faixa_alvo` VARCHAR(1) NULL AFTER `exames_por_ano`,
ADD COLUMN `pop_25_64` INT NULL AFTER `faixa_alvo`;

#create indices
ALTER TABLE `siscolo`.`citologico` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `municipio_coleta` (`municipio_coleta` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

update siscolo.citologico set atipias_l = '1' where C_ATI_ESC = '1' OR C_CEL_ESCA= '1';
update siscolo.citologico set atipias_h = '1' where  C_ATI_ESC = '2' OR C_ATI_GLA = '1' OR C_ATI_GLA = '2' OR C_CEL_ESCA= '2' OR C_CEL_ESCA= '3' OR C_ATI_IND = '1' OR C_ATI_IND = '2';
Update siscolo.citologico set cancers = '1' where  C_GLA_ADEN = '1' OR C_GLA_ADEN = '2' OR C_GLA_ADEN = '3' OR C_GLA_ADEN = '4' OR C_CEL_ESCA= '4';
Update siscolo.citologico set alt_ben = '1' where C_BEM_INFL = '3' OR CBEMMETAS = '3' OR  CBEMREPAR = '3' OR CBEMATROF= '3' OR CBEMRADIA= '3'OR C_BEM_OUT ='3';
# OR C_BEM_OUTR IS NOT NULL AND TRIM(C_BEM_OUTR) <> ''; #trim used to eliminate the space (this part was not used in the query)
Update siscolo.citologico set res_nao_alt = '1' where  alt_ben = '1' or C_RES_NORM = '3';
update siscolo.citologico set nics_cancers = '1' where C_CEL_ESCA= '1' OR C_CEL_ESCA= '2' or C_CEL_ESCA = '4';
Update siscolo.citologico set nic2_nic3 = '1' where C_CEL_ESCA= '2';
update siscolo.citologico set laminas_rejs = '1' WHERE (C_REJ_AUS = '3') OR (C_REJ_DAN ='3') OR (C_REJ_ALH ='3') OR (C_REJ_OUT ='3');
update siscolo.citologico set laminas_insat = '1' WHERE C_ADQ_ACEL= '3' OR C_ADQ_SANG= '3' OR C_ADQ_PIO =  '3' OR C_ADQ_ART= '3' OR C_ADQ_CONT= '3' OR C_ADQ_INT = '3' OR C_ADQ_OUT = '3';
update siscolo.citologico set laminas_sat = '1' WHERE C_ADQ_MAT= '3';
update siscolo.citologico set zt = '1' where C_EPI_GLA = '3' OR C_EPI_MET = '3';
Update siscolo.citologico set ascus_asch= '1' where C_ATI_ESC='1' or C_ATI_ESC='2';
Update siscolo.citologico set lsil_hsil= '1' where C_CEL_ESCA='1' or C_CEL_ESCA='2';
Update siscolo.citologico set res_alterados= '1' where atipias_l='1' or atipias_h='1' or cancers='1';

#############################################JOIN OF normal & ascus ##############################
create table siscolo.normal SELECT count(C_RES_NORM) norm, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.citologico where C_RES_NORM = '3' group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES ;

Create table siscolo.ascus SELECT count(C_ATI_ESC) as asc_us, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
 C_ATI_ESC = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

CREATE TABLE siscolo.norm_ascus_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
	t2.asc_us FROM
    siscolo.normal t1
        LEFT JOIN
    siscolo.ascus t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.norm_ascus_right SELECT
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia ,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.norm,
	t2.asc_us
    
    FROM siscolo.normal t1
        RIGHT JOIN
 siscolo.ascus t2 
   
ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.norm_ascus SELECT * FROM siscolo.norm_ascus_right UNION SELECT * FROM  siscolo.norm_ascus_left;

#*****
 #############################################JOIN OF norm_ascus & nic1 ################################################
Create table siscolo.nic1
SELECT 
count(C_CEL_ESCA) as lsil, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
 C_CEL_ESCA= '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;


CREATE TABLE siscolo.ascus_nic1_left SELECT t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t2.lsil FROM
    siscolo.norm_ascus t1
        LEFT JOIN
    siscolo.nic1 t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.ascus_nic1_right SELECT t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.norm,
    t1.asc_us,
    t2.lsil FROM
    siscolo.norm_ascus t1
        RIGHT JOIN
    siscolo.nic1 t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.ascus_nic1 SELECT * FROM siscolo.ascus_nic1_right UNION SELECT * FROM siscolo.ascus_nic1_left;
#*****

#############################################JOIN OF ascus_nic1 & escamh ################################################
Create table siscolo.escamh
SELECT 
count(C_ATI_ESC) as asc_h, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_ATI_ESC = '2'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

CREATE TABLE siscolo.nic1_escam_left SELECT
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
     t1.norm,
        t1.asc_us,
    t1.lsil,
    t2.asc_h FROM
    siscolo.ascus_nic1 t1
        LEFT JOIN
    siscolo.escamh t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.nic1_escam_right SELECT
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta ,
    t2.C_CNES,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t2.asc_h
    
    FROM
siscolo.ascus_nic1 t1
        RIGHT JOIN
siscolo.escamh t2 
  ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;
CREATE TABLE siscolo.nic1_escamh SELECT * FROM siscolo.nic1_escam_right UNION SELECT * FROM siscolo.nic1_escam_left;
#****
#############################################JOIN OF nic1_escamh & gland ################################################
Create table siscolo.gland
SELECT 
count(C_ATI_GLA) as agc, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_ATI_GLA = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

CREATE TABLE siscolo.escamh_gland_left SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t2.agc FROM
    siscolo.nic1_escamh t1
        LEFT JOIN
    siscolo.gland t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.escamh_gland_right SELECT
	t2.id_tempo,
    t2.faixa_etaria ,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES ,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t2.agc
    
    FROM
siscolo.nic1_escamh t1
        RIGHT JOIN
siscolo.gland t2 
   ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.escamh_gland SELECT * FROM  siscolo.escamh_gland_right UNION SELECT * FROM siscolo.escamh_gland_left;

#############################################JOIN OF escamh_gland & glandh ################################################

Create table siscolo.glandh
SELECT 
count(C_ATI_GLA) as agc_h, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_ATI_GLA = '2'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

CREATE TABLE siscolo.gland_glandh_left SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
       t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t2.agc_h FROM
    siscolo.escamh_gland t1
        LEFT JOIN
    siscolo.glandh t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.gland_glandh_right SELECT
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES ,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t2.agc_h
    
    FROM
siscolo.escamh_gland t1
        RIGHT JOIN
siscolo.glandh t2 
  ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.gland_glandh SELECT * FROM siscolo.gland_glandh_right UNION SELECT * FROM siscolo.gland_glandh_left;
#******

#############################################JOIN OF gland_glandh & nic2 ####################################################

CREATE TABLE siscolo.nic2 SELECT COUNT(C_CEL_ESCA) AS hsil,
    id_tempo,
    faixa_etaria,
    C_CNES,
    id_u_coleta,
    municipio_residencia FROM
    siscolo.citologico
WHERE
    C_CEL_ESCA = '2'
GROUP BY id_tempo , faixa_etaria , C_CNES , id_u_coleta , municipio_residencia;

CREATE TABLE siscolo.glandh_nic2_left SELECT t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
       t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t2.hsil FROM
    siscolo.gland_glandh t1
        LEFT JOIN
    siscolo.nic2 t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.glandh_nic2_right SELECT
	t2.id_tempo ,
    t2.faixa_etaria ,
    t2.municipio_residencia,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t2.hsil
    
    FROM
siscolo.gland_glandh t1
        RIGHT JOIN
siscolo.nic2 t2 
   ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.glandh_nic2 SELECT * FROM  siscolo.glandh_nic2_right UNION SELECT * FROM siscolo.glandh_nic2_left;
#***

#############################################JOIN OF glandh_nic2 & microinvas #######################################

Create table siscolo.microinvas
SELECT 
count(C_CEL_ESCA) as hil_microinvas, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_CEL_ESCA= '3'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

create table siscolo.nic2_microinvas_left 
      SELECT 
       t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
       t1.norm,
              t1. asc_us,
       t1.lsil,
       t1.asc_h,
       t1.agc,
       t1.agc_h,
       t1.hsil,
       t2.hil_microinvas

FROM  siscolo.glandh_nic2  t1

LEFT JOIN 
siscolo.microinvas t2

ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.nic2_microinvas_right SELECT
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t2.hil_microinvas
    
    FROM
siscolo.glandh_nic2 t1
        RIGHT JOIN
siscolo.microinvas t2 
   ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.nic2_microinvas SELECT * FROM siscolo.nic2_microinvas_right UNION SELECT * FROM siscolo.nic2_microinvas_left;
#***
#############################################JOIN OF nic2_microinvas & adenocarcinoma #######################################

Create table siscolo.adenocarcinoma
SELECT 
count(C_GLA_ADEN) as aden_insitu, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_GLA_ADEN = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

CREATE TABLE siscolo.microinvas_adenocarcinoma_left SELECT t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t2.aden_insitu FROM
    siscolo.nic2_microinvas t1
        LEFT JOIN
    siscolo.adenocarcinoma t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.microinvas_adenocarcinoma_right SELECT
	t2.id_tempo,
    t2.faixa_etaria ,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t2.aden_insitu
    
    FROM
siscolo.nic2_microinvas t1
        RIGHT JOIN
siscolo.adenocarcinoma t2 
    ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;


CREATE TABLE siscolo.microinvas_adenocarcinoma SELECT * FROM siscolo.microinvas_adenocarcinoma_right UNION SELECT * FROM siscolo.microinvas_adenocarcinoma_left;
#***
#############################################JOIN OF microinvas_adenocarcinoma & cervical ########################
Create table siscolo.cervical 
SELECT 
count(C_GLA_ADEN) as aden_invas_cervical, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_GLA_ADEN = '2'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

CREATE TABLE siscolo.adenocarcinoma_cervical_left SELECT t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t2.aden_invas_cervical FROM
    siscolo.microinvas_adenocarcinoma t1
        LEFT JOIN
    siscolo.cervical t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.c_cnes;

CREATE TABLE siscolo.adenocarcinoma_cervical_right SELECT
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.norm,
       t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t2.aden_invas_cervical
    
    FROM
 siscolo.microinvas_adenocarcinoma t1
        RIGHT JOIN
siscolo.cervical t2 
   ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.adenocarcinoma_cervical SELECT * FROM siscolo.adenocarcinoma_cervical_right UNION SELECT * FROM siscolo.adenocarcinoma_cervical_left;
#****
############################################JOIN OF adenocarcinoma_cervical & endometrial ########################

Create table siscolo.endometrial
SELECT 
count(C_GLA_ADEN) as aden_invas_endometrial, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_GLA_ADEN = '3'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

create table siscolo.cervical_endometrial_left 
      SELECT 
       t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
       t1.norm,
        t1. asc_us,
       t1.lsil,
       t1.asc_h,
       t1.agc,
       t1.agc_h,
       t1.hsil,
       t1.hil_microinvas,
       t1.aden_insitu,
       t1.aden_invas_cervical,
       t2.aden_invas_endometrial

FROM siscolo.adenocarcinoma_cervical  t1

LEFT JOIN 
siscolo.endometrial t2

ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.cervical_endometrial_right SELECT
	t2.id_tempo,
    t2.faixa_etaria ,
    t2.municipio_residencia,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
       t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t2.aden_invas_endometrial
        
    FROM
 siscolo.adenocarcinoma_cervical t1
        RIGHT JOIN
siscolo.endometrial t2 
   ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.cervical_endometrial SELECT * FROM siscolo.cervical_endometrial_right UNION SELECT * FROM siscolo.cervical_endometrial_left;
#***
###########################################JOIN OF cervical_endometrial & invas_outros ################################

Create table siscolo.invas_outros
SELECT 
count(C_GLA_ADEN) as aden_invas_cervical_outros, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_GLA_ADEN = '4'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

CREATE TABLE siscolo.endometrial_invas_left SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t2.aden_invas_cervical_outros FROM
    siscolo.cervical_endometrial t1
        LEFT JOIN
    siscolo.invas_outros t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.endometrial_invas_right SELECT t2.id_tempo ,
    t2.faixa_etaria ,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES ,
    t1.norm,
        t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t2.aden_invas_cervical_outros FROM
    siscolo.cervical_endometrial t1
        RIGHT JOIN
    siscolo.invas_outros t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.endometrial_invas SELECT * FROM siscolo.endometrial_invas_right UNION SELECT * FROM siscolo.endometrial_invas_left;
#**
########################################JOIN OF endometrial_invas & carcinoma ###########################

Create table siscolo.carcinoma
SELECT 
count(C_NEO_MALI) as carcinoma_invas, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_CEL_ESCA= '4'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

create table siscolo.endometri_carcinoma_left 
      SELECT 
      t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
       t1.norm,
        t1. asc_us,
       t1.lsil,
       t1.asc_h,
       t1.agc,
       t1.agc_h,
       t1.hsil,
       t1.hil_microinvas,
       t1.aden_insitu,
       t1.aden_invas_cervical,
       t1.aden_invas_endometrial,
       t1.aden_invas_cervical_outros,
	   t2.carcinoma_invas

FROM siscolo.endometrial_invas  t1

LEFT JOIN 
siscolo.carcinoma t2

ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.c_cnes;

CREATE TABLE siscolo.endometri_carcinoma_right SELECT t2.id_tempo,
    t2.faixa_etaria ,
    t2.municipio_residencia,
    t2.id_u_coleta ,
    t2.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
     t2.carcinoma_invas

FROM siscolo.endometrial_invas  t1
        RIGHT JOIN
 siscolo.carcinoma t2 
    ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;
   
CREATE TABLE siscolo.endometri_carcinoma SELECT * FROM  siscolo.endometri_carcinoma_right UNION SELECT * FROM siscolo.endometri_carcinoma_left;
#*****		
#######################################JOIN OF endometri_carcinoma & celula_ind ##################################
Create table siscolo.celula_ind
SELECT 
count(C_ATI_IND) as ac_ind, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_ATI_IND = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

create table siscolo.carcinoma_celula_ind_left 
      SELECT 
       t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
       t1.norm,
       t1. asc_us,
       t1.lsil,
       t1.asc_h,
       t1.agc,
       t1.agc_h,
       t1.hsil,
       t1.hil_microinvas,
       t1.aden_insitu,
       t1.aden_invas_cervical,
       t1.aden_invas_endometrial,
       t1.aden_invas_cervical_outros,
       t1.carcinoma_invas,
       t2.ac_ind

FROM siscolo.endometri_carcinoma  t1

LEFT JOIN 
siscolo.celula_ind t2

ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.carcinoma_celula_ind_right SELECT t2.id_tempo,
    t2.faixa_etaria ,
    t2.municipio_residencia ,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
     t1.carcinoma_invas,
    t2.ac_ind

FROM siscolo.endometri_carcinoma  t1
        RIGHT JOIN
siscolo.celula_ind t2 
   ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.carcinoma_celula_ind SELECT * FROM  siscolo.carcinoma_celula_ind_right UNION SELECT * FROM siscolo.carcinoma_celula_ind_left;
#***
#######################################JOIN OF ecarcinoma_celula_ind & celula_indh ##########################
Create table siscolo.celula_indh
SELECT 
count(C_ATI_IND) as ac_ind_h, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
C_ATI_IND = '2'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

create table siscolo.ind_indh_left 
      SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
       t1.norm,
         t1. asc_us,
       t1.lsil,
       t1.asc_h,
       t1.agc,
       t1.agc_h,
       t1.hsil,
       t1.hil_microinvas,
       t1.aden_insitu,
       t1.aden_invas_cervical,
       t1.aden_invas_endometrial,
       t1.aden_invas_cervical_outros,
          t1.carcinoma_invas,
       t1.ac_ind,
       t2.ac_ind_h

FROM siscolo.carcinoma_celula_ind  t1

LEFT JOIN 
siscolo.celula_indh t2

 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.ind_indh_right SELECT 
	t2.id_tempo,
    t2.faixa_etaria ,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES ,
    t1.norm,
     t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t2.ac_ind_h

FROM siscolo.carcinoma_celula_ind   t1
        RIGHT JOIN
siscolo.celula_indh t2 
    ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.ind_indh SELECT * FROM siscolo.ind_indh_right UNION SELECT * FROM siscolo.ind_indh_left;
#######################################JOIN OF ind_indh & exames_total ##########################
Create table siscolo.exames_total
SELECT 
count(id_) as nt_exames, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`ind_indh` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

ALTER TABLE `siscolo`.`exames_total` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

create table siscolo.indh_exames_total_left 
      SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
       t1.norm,
       t1. asc_us,
       t1.lsil,
       t1.asc_h,
       t1.agc,
       t1.agc_h,
       t1.hsil,
       t1.hil_microinvas,
       t1.aden_insitu,
       t1.aden_invas_cervical,
       t1.aden_invas_endometrial,
       t1.aden_invas_cervical_outros,
           t1.carcinoma_invas,
       t1.ac_ind,
       t1.ac_ind_h,
       t2.nt_exames

FROM siscolo.ind_indh  t1

LEFT JOIN 
siscolo.exames_total t2
 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;
   
CREATE TABLE siscolo.indh_exames_total_right SELECT t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia ,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
     t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
      t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t2.nt_exames

FROM siscolo.ind_indh   t1
        RIGHT JOIN
siscolo.exames_total t2 
     ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.indh_exames_total SELECT * FROM  siscolo.indh_exames_total_right UNION SELECT * FROM  siscolo.indh_exames_total_left;

ALTER TABLE `siscolo`.`indh_exames_total` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

#***
############################JOIN OF indh_exames_total & atipias_l##################################################
create table siscolo.atipias_l SELECT count(atipias_l) as atipias_l , id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
 atipias_l = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`atipias_l` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

create table siscolo.exames_total_atipiasl_left 
      SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
       t1.norm,
       t1. asc_us,
       t1.lsil,
       t1.asc_h,
       t1.agc,
       t1.agc_h,
       t1.hsil,
       t1.hil_microinvas,
       t1.aden_insitu,
       t1.aden_invas_cervical,
       t1.aden_invas_endometrial,
       t1.aden_invas_cervical_outros,
        t1.carcinoma_invas,
       t1.ac_ind,
       t1.ac_ind_h,
       t1.nt_exames,
       t2.atipias_l

FROM siscolo.indh_exames_total  t1

LEFT JOIN 
siscolo.atipias_l t2
 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;
   
CREATE TABLE siscolo.exames_total_atipiasl_right SELECT 
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia ,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t2.atipias_l

FROM siscolo.indh_exames_total   t1
        RIGHT JOIN
siscolo.atipias_l t2 
     ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.total_atipias_l SELECT * FROM  siscolo.exames_total_atipiasl_right UNION SELECT * FROM  siscolo.exames_total_atipiasl_left;

ALTER TABLE `siscolo`.`total_atipias_l` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

########################################JOIN OF total_atipias_l & atipias_h $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

CREATE TABLE siscolo.atipias_h SELECT COUNT(atipias_h) AS atipias_h,
    id_tempo,
    faixa_etaria,
    C_CNES,
    id_u_coleta,
    municipio_residencia FROM
    siscolo.citologico
WHERE
    atipias_h = '1'
GROUP BY id_tempo , faixa_etaria , C_CNES , id_u_coleta , municipio_residencia;

ALTER TABLE `siscolo`.`atipias_h` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

CREATE TABLE siscolo.total_atipiasl_atipiash_left SELECT
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t2.atipias_h 
    FROM
    siscolo.total_atipias_l t1
        LEFT JOIN
    siscolo.atipias_h t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

ALTER TABLE `siscolo`.`total_atipiasl_atipiash_left` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);
   
CREATE TABLE siscolo.total_atipiasl_atipiash_right SELECT 
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia ,
    t2.id_u_coleta ,
    t2.C_CNES,
    t1.norm,
     t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
     t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t2.atipias_h

FROM siscolo.total_atipias_l   t1
        RIGHT JOIN
siscolo.atipias_h t2 
     ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;
   
CREATE TABLE siscolo.atipias_l_atipias_h SELECT * FROM  siscolo.total_atipiasl_atipiash_right UNION SELECT * FROM siscolo.total_atipiasl_atipiash_left;

ALTER TABLE `siscolo`.`atipias_l_atipias_h` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

###########################################JOIN OF atipias_l_atipias_h & alt_ben ############################
Create table siscolo.alt_ben SELECT count(alt_ben) as alt_ben , id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
 alt_ben = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`alt_ben` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

CREATE TABLE siscolo.atipias_lh_alt_left SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t2.alt_ben
    FROM
    siscolo.atipias_l_atipias_h t1
        LEFT JOIN
   siscolo.alt_ben t2 ON 
   t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.atipias_lh_alt_right SELECT 
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia ,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
   t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t2.alt_ben

FROM siscolo.atipias_l_atipias_h  t1
        RIGHT JOIN
siscolo.alt_ben t2 
     ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.atipias_altben SELECT * FROM  siscolo.atipias_lh_alt_right UNION SELECT * FROM  siscolo.atipias_lh_alt_left;

ALTER TABLE `siscolo`.`atipias_altben` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

###################################################join of atipias_altben & res_nao_alt#####################

Create table siscolo.res_nao_alt SELECT count(res_nao_alt) as res_nao_alt, id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
 res_nao_alt = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`res_nao_alt` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

CREATE TABLE siscolo.altben_res_nao_alt_left SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t1.alt_ben,
    t2.res_nao_alt
    FROM
    siscolo.atipias_altben t1
        LEFT JOIN
   siscolo.res_nao_alt t2 ON 
   	t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.altben_res_nao_alt_right SELECT 
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia ,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
	t1.atipias_h,
    t1.alt_ben,
    t2.res_nao_alt
FROM
    siscolo.atipias_altben t1
        right JOIN
   siscolo.res_nao_alt t2 ON  t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.altben_res_nao_alt SELECT * FROM  siscolo.altben_res_nao_alt_right UNION SELECT * FROM  siscolo.altben_res_nao_alt_left;

ALTER TABLE `siscolo`.`altben_res_nao_alt` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

######################join of altben_res_nao_alt with cancers#############################################

Create table siscolo.cancers SELECT count(cancers) as cancers , id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
 cancers = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`cancers` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

CREATE TABLE siscolo.nao_alt_cancers_left SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t2.cancers
    FROM
    siscolo.altben_res_nao_alt t1
        LEFT JOIN
   siscolo.cancers t2 ON 
   t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.nao_alt_cancers_right SELECT 
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia ,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
     t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
     t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
	t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t2.cancers
    FROM
    siscolo.altben_res_nao_alt t1
        right JOIN
   siscolo.cancers t2 ON  t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.nao_alt_cancers SELECT * FROM  siscolo.nao_alt_cancers_right UNION SELECT * FROM  siscolo.nao_alt_cancers_left;

ALTER TABLE `siscolo`.`nao_alt_cancers` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);
######################join of nao_alt_cancers with nics_cancer#############################################

Create table siscolo.nics_cancers SELECT count(nics_cancers) as nics_cancers , id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
 nics_cancers = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`nics_cancers` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

CREATE TABLE siscolo.alt_nics_cancers_left SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t1.cancers,
    t2.nics_cancers
    FROM
    siscolo.nao_alt_cancers t1
        LEFT JOIN
   siscolo.nics_cancers t2 ON 
   t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.alt_nics_cancers_right SELECT 
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia ,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
	t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t1.cancers,
    t2.nics_cancers
    FROM
    siscolo.nao_alt_cancers t1
        right JOIN
   siscolo.nics_cancers t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.alt_nics_cancers SELECT * FROM  siscolo.alt_nics_cancers_right UNION SELECT * FROM  siscolo.alt_nics_cancers_left;

ALTER TABLE `siscolo`.`alt_nics_cancers` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

######################join of alt_nics_cancerss with nic2_nic3############################################

Create table siscolo.nic2_nic3 SELECT count(nic2_nic3) as nic2_nic3 , id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia
FROM  siscolo.citologico
WHERE
 nic2_nic3 = '1'
GROUP BY
id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`nic2_nic3` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

CREATE TABLE siscolo.nics23_cancers_left SELECT 
	t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
     t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t1.cancers,
    t1.nics_cancers,
    t2.nic2_nic3
    FROM
    siscolo.alt_nics_cancers t1
        LEFT JOIN
   siscolo.nic2_nic3 t2 ON 
   t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.nics23_cancers_right SELECT 
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta ,
    t2.C_CNES ,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
	t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t1.cancers,
    t1.nics_cancers,
    t2.nic2_nic3
    FROM
    siscolo.alt_nics_cancers t1
        right JOIN
   siscolo.nic2_nic3 t2 ON 
   t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.nics23_cancers SELECT * FROM  siscolo.nics23_cancers_right UNION SELECT * FROM  siscolo.nics23_cancers_left;

ALTER TABLE `siscolo`.`nics23_cancers` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

######################################################################################################################
###########################Indicators for quality of slices#########################################################
#########################join of tables Reject & insatisfatorias####################################################
CREATE TABLE siscolo.reject  SELECT  COUNT(laminas_rejs) AS laminas_rejetadas,    id_tempo,    faixa_etaria,    C_CNES,    id_u_coleta,    municipio_residencia FROM   siscolo.citologico
WHERE
    laminas_rejs = '1'
GROUP BY id_tempo , faixa_etaria , C_CNES , id_u_coleta , municipio_residencia;

ALTER TABLE `siscolo`.`reject` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

Create table siscolo.insatisfatorias SELECT  count(laminas_insat) AS laminas_insatisfatorias, id_tempo,    faixa_etaria,    C_CNES,    id_u_coleta,    municipio_residencia FROM    siscolo.citologico
WHERE
laminas_insat = '1'
GROUP BY id_tempo , faixa_etaria , C_CNES , id_u_coleta , municipio_residencia;

ALTER TABLE `siscolo`.`insatisfatorias` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

create table siscolo.rej_insat_left SELECT 
	   t1.id_tempo,
       t1.faixa_etaria,
       t1.municipio_residencia,
       t1.id_u_coleta,
       t1.C_CNES,
       t1.laminas_rejetadas,
       t2.laminas_insatisfatorias
FROM siscolo.reject t1
LEFT JOIN 
siscolo.insatisfatorias t2

 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

   
    create table siscolo.rej_insat_right SELECT
       t2.id_tempo,
       t2.faixa_etaria,
       t2.municipio_residencia,
       t2.id_u_coleta,
       t2.C_CNES,
       t1.laminas_rejetadas,
       t2.laminas_insatisfatorias
FROM siscolo.reject t1 
right JOIN
 siscolo.insatisfatorias t2
  ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

   create table siscolo.rej_insat SELECT * FROM siscolo.rej_insat_right union select * from siscolo.rej_insat_left;

ALTER TABLE `siscolo`.`rej_insat` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);


   #***
#########################################JOIN of rej_insat &  satisfatorias #################################
  
Create table  siscolo.satisfatorias SELECT  COUNT(laminas_sat) AS laminas_satisfatorias, id_tempo,    faixa_etaria,    C_CNES,    id_u_coleta,    municipio_residencia FROM    siscolo.citologico
WHERE
laminas_sat = '1'
GROUP BY id_tempo , faixa_etaria , C_CNES , id_u_coleta , municipio_residencia;

ALTER TABLE `siscolo`.`satisfatorias` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

CREATE TABLE siscolo.insat_sat_left SELECT 
    t1.id_tempo,
       t1.faixa_etaria,
       t1.municipio_residencia,
       t1.id_u_coleta,
       t1.C_CNES,
  	t1.laminas_rejetadas,
	t1.laminas_insatisfatorias,
    t2.laminas_satisfatorias FROM
    siscolo.rej_insat t1
        LEFT JOIN
    siscolo.satisfatorias t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.insat_sat_right
 SELECT
   t2.id_tempo,
       t2.faixa_etaria,
       t2.municipio_residencia,
       t2.id_u_coleta,
       t2.C_CNES,
    t1.laminas_rejetadas,
	t1.laminas_insatisfatorias,
    t2.laminas_satisfatorias
    FROM
    siscolo.rej_insat t1
        RIGHT JOIN
    siscolo.satisfatorias t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;


CREATE TABLE siscolo.insat_sat SELECT * FROM siscolo.insat_sat_right UNION SELECT * FROM siscolo.insat_sat_left;

ALTER TABLE `siscolo`.`insat_sat` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

#**
################################################JOIN of insat_sat &  zt ##########################################  

Create table  siscolo.zt  SELECT  COUNT(zt) AS zt, id_tempo,    faixa_etaria,    C_CNES,    id_u_coleta,    municipio_residencia FROM    siscolo.citologico
WHERE
zt = '1'
GROUP BY id_tempo , faixa_etaria , C_CNES , id_u_coleta , municipio_residencia;

ALTER TABLE `siscolo`.`zt` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

CREATE TABLE siscolo.sat_zt_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.laminas_rejetadas,
    t1.laminas_insatisfatorias,
    t1.laminas_satisfatorias,
    t2.zt FROM
    siscolo.insat_sat t1
        LEFT JOIN
    siscolo.zt t2  ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.sat_zt_right
 SELECT
    t2.id_tempo,
       t2.faixa_etaria,
       t2.municipio_residencia,
       t2.id_u_coleta,
       t2.C_CNES,
    t1.laminas_rejetadas,
	t1.laminas_insatisfatorias,
    t1.laminas_satisfatorias,
    t2.zt
    FROM
    siscolo.insat_sat t1
        RIGHT JOIN
    siscolo.zt t2  ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.sat_zt SELECT * FROM siscolo.sat_zt_right UNION SELECT * FROM siscolo.sat_zt_left;

ALTER TABLE `siscolo`.`sat_zt` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

      #**
###################### JOIN OF nics23_cancers (table of exam indicators) & sat_zt#################################
   CREATE TABLE siscolo.fatos_citologico_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t1.cancers,
    t1.nics_cancers,
    t1.nic2_nic3,
    t2.laminas_rejetadas,
    t2.laminas_insatisfatorias,
    t2.laminas_satisfatorias,
    t2.zt FROM
    siscolo.nics23_cancers t1
        LEFT JOIN
    siscolo.sat_zt t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

   CREATE TABLE siscolo.fatos_citologico_right SELECT
    t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t1.cancers,
    t1.nics_cancers,
    t1.nic2_nic3,
    t2.laminas_rejetadas,
    t2.laminas_insatisfatorias,
    t2.laminas_satisfatorias,
    t2.zt FROM
    siscolo.nics23_cancers t1
        right JOIN
    siscolo.sat_zt t2 ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;
   
CREATE TABLE siscolo.fatos_citologico SELECT * FROM siscolo.fatos_citologico_right UNION SELECT * FROM siscolo.fatos_citologico_left;

create table siscolo.ascus_asch select count(ascus_asch) ascus_asch, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES FROM 
siscolo.citologico where ascus_asch='1' group by id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`ascus_asch` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

 ##create table lsil_hsil:
create table siscolo.lsil_hsil select count(lsil_hsil) lsil_hsil, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES FROM 
siscolo.citologico where lsil_hsil='1' group by id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`lsil_hsil` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

 ##create table res_alterados 
create table siscolo.res_alterados select count(res_alterados) res_alterados, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES FROM 
siscolo.citologico where res_alterados='1' group by id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`res_alterados` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

create table siscolo.exames_por_ano select count(id_) as exames_por_ano, substr(C_COMP,1,4) as ano from siscolo.citologico group by substr(C_COMP,1,4);

update siscolo.citologico c set exames_por_ano =(select exames_por_ano from siscolo.exames_por_ano e where substr(C_COMP,1,4)= e.ano);

create table siscolo.exames_total_geral SELECT exames_por_ano,  faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES FROM 
siscolo.citologico group by id_tempo, faixa_etaria, C_CNES, id_u_coleta, municipio_residencia;

ALTER TABLE `siscolo`.`exames_total_geral` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);




