#create variables
ALTER TABLE `siscolo`.`histologico` 
ADD COLUMN `lesoes_carater_benigno_histo` VARCHAR(1) NULL AFTER `id_tempo`,
ADD COLUMN `lesoes_pre_neoplasico_histo` VARCHAR(1) NULL AFTER `lesoes_carater_benigno_histo`,
ADD COLUMN `carcinomas_histo` VARCHAR(1) NULL AFTER `lesoes_pre_neoplasico_histo`,
ADD COLUMN `adenocarcinomas_histo` VARCHAR(1) NULL AFTER `carcinomas_histo`;

#create indices
ALTER TABLE `siscolo`.`histologico` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `municipio_coleta` (`municipio_coleta` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

#Lesões de caráter benigno
UPDATE siscolo.histologico set lesoes_carater_benigno_histo = "1" where C_BEN_META = "3" or C_BEN_POLI = "3" or
CBENSERVI = "3" or CBENALTER = "3";
# Lesões de caráter neoplásico ou préneoplásico
UPDATE siscolo.histologico set lesoes_pre_neoplasico_histo = "1" where CNEONICAR = "1" or CNEONICAR = "2" or  CNEONICAR = "3"
or  CNEONICAR = "4" or  CNEONICAR = "5" or  CNEONICAR = "6" or  CNEONICAR = "7" or  CNEONICAR = "8" or C_NEO_ADEN = "1"
or C_NEO_ADEN = "2" or C_NEO_ADEN = "3";
#Carcinomas
UPDATE siscolo.histologico set carcinomas_histo= "1" where CNEONICAR = "4" or  CNEONICAR = "5" or  CNEONICAR = "6" 
or  CNEONICAR = "7" or  CNEONICAR = "8";
#adenocarcinomas
UPDATE siscolo.histologico set adenocarcinomas_histo= "1" where C_NEO_ADEN = "1" or C_NEO_ADEN = "2" or C_NEO_ADEN = "3";

#############################################JOIN OF nic1 & nic2 ##################################
create table siscolo.nic1_histo SELECT count(CNEONICAR) nic1_histo, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.histologico where CNEONICAR = '1' group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES ;

create table siscolo.nic2_histo SELECT count(CNEONICAR) nic2_histo, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.histologico where CNEONICAR = '2' group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES  ;

CREATE TABLE siscolo.nic12_histo_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.nic1_histo,
	t2.nic2_histo FROM
  siscolo.nic1_histo t1
        LEFT JOIN
    siscolo.nic2_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.nic12_histo_right SELECT
	t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
     t1.nic1_histo,
	t2.nic2_histo FROM
  siscolo.nic1_histo t1
        RIGHT JOIN
    siscolo.nic2_histo t2
   ON t1.id_tempo=t2.id_tempo and t1.faixa_etaria=t2.faixa_etaria AND t1.municipio_residencia=t2.municipio_residencia AND
   t1.id_u_coleta=t2.id_u_coleta AND t1.C_CNES=t2.C_CNES;

CREATE TABLE siscolo.nic12_histo SELECT * FROM   siscolo.nic12_histo_right UNION SELECT * FROM  siscolo.nic12_histo_left;
########################################### JOIN OF nic12_histo & NIC3 ########################################################

create table siscolo.nic3_histo SELECT count(CNEONICAR) as nic3_histo, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.histologico where CNEONICAR = '3' group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES ;

CREATE TABLE siscolo.nic123_histo_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.nic1_histo,
	t1.nic2_histo,
	t2.nic3_histo
    FROM
  siscolo.nic12_histo t1
        LEFT JOIN
    siscolo.nic3_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.nic123_histo_right SELECT 
    t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.nic1_histo,
    t1.nic2_histo,
    t2.nic3_histo 
    FROM    
    siscolo.nic12_histo t1
       Right JOIN
    siscolo.nic3_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
        
CREATE TABLE siscolo.nic123_histo SELECT * FROM siscolo.nic123_histo_right UNION SELECT * FROM siscolo.nic123_histo_left;
   
########################################### JOIN OF nic123_histo & lesoes_carater_benigno ########################################################

create table siscolo.lesoes_carater_benigno_histo SELECT count(lesoes_carater_benigno_histo) as lesoes_carater_benigno_histo, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.histologico where lesoes_carater_benigno_histo = '1' group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES ;

CREATE TABLE siscolo.nic123_lesoes_benigno_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.nic1_histo,
	t1.nic2_histo,
	t1.nic3_histo,
    t2.lesoes_carater_benigno_histo
    FROM
  siscolo.nic123_histo t1
        LEFT JOIN
    siscolo.lesoes_carater_benigno_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.nic123_lesoes_benigno_right SELECT t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.nic1_histo,
    t1.nic2_histo,
    t1.nic3_histo,
    t2.lesoes_carater_benigno_histo
    
    FROM
    siscolo.nic123_histo t1
      right JOIN
     siscolo.lesoes_carater_benigno_histo t2
     ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
        
 CREATE TABLE siscolo.nic123_lesoes_benigno SELECT * FROM siscolo.nic123_lesoes_benigno_right UNION SELECT * FROM siscolo.nic123_lesoes_benigno_left;    
 
###############################################join of nic123_lesoes_benigno & lesoes_pre_neoplasico_histo############################################################        


create table siscolo.lesoes_pre_neoplasico_histo SELECT count(lesoes_pre_neoplasico_histo) as lesoes_pre_neoplasico_histo, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.histologico where lesoes_pre_neoplasico_histo = '1' group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES ;

CREATE TABLE siscolo.nic123_pre_neoplasico_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.nic1_histo,
	t1.nic2_histo,
	t1.nic3_histo,
    t1.lesoes_carater_benigno_histo,
    t2.lesoes_pre_neoplasico_histo
    
    FROM
  siscolo.nic123_lesoes_benigno  t1
        LEFT JOIN
    siscolo.lesoes_pre_neoplasico_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.nic123_pre_neoplasico_right SELECT t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.nic1_histo,
    t1.nic2_histo,
    t1.nic3_histo,
     t1.lesoes_carater_benigno_histo,
    t2.lesoes_pre_neoplasico_histo
    
    FROM
  siscolo.nic123_lesoes_benigno t1
      right JOIN
    siscolo.lesoes_pre_neoplasico_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.nic123_pre_neoplasico SELECT * FROM siscolo.nic123_pre_neoplasico_right UNION SELECT * FROM siscolo.nic123_pre_neoplasico_left;  

####################################JOIN OF nic123_pre_neoplasico & carcinomas_histo##########################################################
  
 create table siscolo.carcinomas_histo SELECT count(carcinomas_histo) as carcinomas_histo, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.histologico where carcinomas_histo = '1' group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES ;

CREATE TABLE siscolo.nic123_pre_carcinomas_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.nic1_histo,
	t1.nic2_histo,
	t1.nic3_histo,
    t1.lesoes_carater_benigno_histo,
    t1.lesoes_pre_neoplasico_histo,
    t2.carcinomas_histo
    
    FROM
  siscolo.nic123_pre_neoplasico t1
        LEFT JOIN
    siscolo.carcinomas_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.nic123_pre_carcinomas_right SELECT t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.nic1_histo,
    t1.nic2_histo,
    t1.nic3_histo,
     t1.lesoes_carater_benigno_histo,
   t1.lesoes_pre_neoplasico_histo,
    t2.carcinomas_histo
    
    FROM
  siscolo.nic123_pre_neoplasico t1
       right JOIN
    siscolo.carcinomas_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.nic123_pre_carcinomas SELECT * FROM siscolo.nic123_pre_carcinomas_right UNION SELECT * FROM siscolo.nic123_pre_carcinomas_left;  

###################################### join of nic123_pre_carcinomas and nt_exam_histo ####################################################
create table siscolo.nt_exam_histo SELECT count(id_) as nt_exam_histo, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.histologico group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES ;

CREATE TABLE siscolo.nic123_nt_exams_histo_left SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.nic1_histo,
	t1.nic2_histo,
	t1.nic3_histo,
    t1.lesoes_carater_benigno_histo,
    t1.lesoes_pre_neoplasico_histo,
    t1.carcinomas_histo,
    t2.nt_exam_histo
    
    FROM
  siscolo.nic123_pre_carcinomas t1
        LEFT JOIN
    siscolo.nt_exam_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.nic123_nt_exam_histo_right SELECT t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.nic1_histo,
    t1.nic2_histo,
    t1.nic3_histo,
     t1.lesoes_carater_benigno_histo,
   t1.lesoes_pre_neoplasico_histo,
    t1.carcinomas_histo,
    t2.nt_exam_histo
    
    FROM
  siscolo.nic123_pre_carcinomas t1
       right JOIN
    siscolo.nt_exam_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.nic123_nt_exam_histo SELECT * FROM siscolo.nic123_nt_exam_histo_right UNION SELECT * FROM siscolo.nic123_nt_exams_histo_left;  


###################################### join of nic123_nt_exam_histo and adenocarcinomas_histo ####################################################

create table siscolo.adenocarcinomas_histo SELECT count(adenocarcinomas_histo) as adenocarcinomas_histo, faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES
FROM siscolo.histologico where adenocarcinomas_histo = '1' group by faixa_etaria, id_tempo, municipio_residencia, id_u_coleta, C_CNES ;

CREATE TABLE siscolo.adeno_l_nt_exam_histo_eft SELECT 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.nic1_histo,
	t1.nic2_histo,
	t1.nic3_histo,
    t1.lesoes_carater_benigno_histo,
    t1.lesoes_pre_neoplasico_histo,
    t1.carcinomas_histo,
    t1.nt_exam_histo,
	t2.adenocarcinomas_histo
    
    FROM
  siscolo.nic123_nt_exam_histo t1
        LEFT JOIN
    siscolo.adenocarcinomas_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
   
CREATE TABLE siscolo.adeno_l_nt_exam_histo_right SELECT
 t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.nic1_histo,
    t1.nic2_histo,
    t1.nic3_histo,
     t1.lesoes_carater_benigno_histo,
   t1.lesoes_pre_neoplasico_histo,
    t1.carcinomas_histo,
    t1.nt_exam_histo,
     t2.adenocarcinomas_histo
        FROM
  siscolo.nic123_nt_exam_histo t1
        right JOIN
    siscolo.adenocarcinomas_histo t2 ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

CREATE TABLE siscolo.fatos_histologico SELECT * FROM siscolo.adeno_l_nt_exam_histo_right UNION SELECT * FROM siscolo.adeno_l_nt_exam_histo_eft;

ALTER TABLE `siscolo`.`fatos_histologico` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

ALTER TABLE `siscolo`.`fatos_citologico` 
ADD INDEX `faixa_etaria` (`faixa_etaria` ASC),
ADD INDEX `residencia` (`municipio_residencia` ASC),
ADD INDEX `lab_coleta` (`id_u_coleta` ASC),
ADD INDEX `tempo` (`id_tempo` ASC),
ADD INDEX `lab_cnes` (`C_CNES` ASC);

###############################JOIN OF fatos_citolgico & fatos_histologico##################

create table siscolo.fatos_producao_left select 
    t1.id_tempo,
    t1.faixa_etaria,
    t1.municipio_residencia,
    t1.id_u_coleta,
    t1.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t1.cancers,
    t1.nics_cancers,
    t1.nic2_nic3,
    t1.laminas_rejetadas,
    t1.laminas_insatisfatorias,
    t1.laminas_satisfatorias,
    t1.zt, 
    t2.nic1_histo,
    t2.nic2_histo,
    t2.nic3_histo,
	t2.lesoes_carater_benigno_histo,
    t2.lesoes_pre_neoplasico_histo,
     t2.carcinomas_histo,
     t2.adenocarcinomas_histo,
     t2.nt_exam_histo
     from 
     siscolo.fatos_citologico t1
     left join
     siscolo.fatos_histologico t2
          ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;

create table siscolo.fatos_producao_right select 
    t2.id_tempo,
    t2.faixa_etaria,
    t2.municipio_residencia,
    t2.id_u_coleta,
    t2.C_CNES,
    t1.norm,
    t1.asc_us,
    t1.lsil,
    t1.asc_h,
    t1.agc,
    t1.agc_h,
    t1.hsil,
    t1.hil_microinvas,
    t1.aden_insitu,
    t1.aden_invas_cervical,
    t1.aden_invas_endometrial,
    t1.aden_invas_cervical_outros,
    t1.carcinoma_invas,
    t1.ac_ind,
    t1.ac_ind_h,
    t1.nt_exames,
    t1.atipias_l,
    t1.atipias_h,
    t1.alt_ben,
    t1.res_nao_alt,
    t1.cancers,
    t1.nics_cancers,
    t1.nic2_nic3,
    t1.laminas_rejetadas,
    t1.laminas_insatisfatorias,
    t1.laminas_satisfatorias,
    t1.zt, 
    t2.nic1_histo,
    t2.nic2_histo,
    t2.nic3_histo,
	t2.lesoes_carater_benigno_histo,
    t2.lesoes_pre_neoplasico_histo,
     t2.carcinomas_histo,
     t2.adenocarcinomas_histo,
	 t2.nt_exam_histo
     from 
     siscolo.fatos_citologico t1
    RIGHT join
     siscolo.fatos_histologico t2
          ON t1.id_tempo = t2.id_tempo
        AND t1.faixa_etaria = t2.faixa_etaria
        AND t1.municipio_residencia = t2.municipio_residencia
        AND t1.id_u_coleta = t2.id_u_coleta
        AND t1.C_CNES = t2.C_CNES;
        
CREATE TABLE siscolo.fatos_producao SELECT * FROM siscolo.fatos_producao_right UNION SELECT * FROM siscolo.fatos_producao_left;

###################Fill nul with Zeros#################################
update siscolo.fatos_producao set norm=0 where norm is null;
update siscolo.fatos_producao set asc_us=0 where asc_us is null;
update siscolo.fatos_producao set lsil=0 where lsil is null;
update siscolo.fatos_producao set asc_h=0 where asc_h is null;
update siscolo.fatos_producao set agc=0 where agc is null;
update siscolo.fatos_producao set agc_h=0 where agc_h is null;
update siscolo.fatos_producao set hsil=0 where hsil is null;
update siscolo.fatos_producao set hil_microinvas=0 where hil_microinvas is null;
update siscolo.fatos_producao set nt_exames=0 where nt_exames is null;
update siscolo.fatos_producao set aden_invas_cervical=0 where aden_invas_cervical is null;
update siscolo.fatos_producao set carcinoma_invas=0 where carcinoma_invas is null;
update siscolo.fatos_producao set ac_ind =0 where ac_ind is null;
update siscolo.fatos_producao set ac_ind_h=0 where ac_ind_h is null;
update siscolo.fatos_producao set aden_invas_endometrial=0 where aden_invas_endometrial is null;
update siscolo.fatos_producao set aden_invas_cervical_outros=0 where aden_invas_cervical_outros is null;
update siscolo.fatos_producao set aden_insitu=0 where aden_insitu is null;
update siscolo.fatos_producao set laminas_rejetadas=0 where laminas_rejetadas is null;
update siscolo.fatos_producao set laminas_insatisfatorias=0 where laminas_insatisfatorias is null;
update siscolo.fatos_producao set laminas_satisfatorias=0 where laminas_satisfatorias is null;
update siscolo.fatos_producao set zt=0 where zt is null;	
update siscolo.fatos_producao set cancers=0 where cancers is null;	
update siscolo.fatos_producao set atipias_l=0 where atipias_l is null;
update siscolo.fatos_producao set atipias_h=0 where atipias_h is null;	
update siscolo.fatos_producao set alt_ben=0 where alt_ben is null;
update siscolo.fatos_producao set res_nao_alt=0 where res_nao_alt is null;
update siscolo.fatos_producao set nics_cancers=0 where nics_cancers is null;
update siscolo.fatos_producao set nic2_nic3=0 where nic2_nic3 is null;
update siscolo.fatos_producao set nic1_histo=0 where nic1_histo is null;
update siscolo.fatos_producao set nic2_histo=0 where nic2_histo is null;
update siscolo.fatos_producao set nic3_histo=0 where nic3_histo is null;
update siscolo.fatos_producao set lesoes_carater_benigno_histo=0 where lesoes_carater_benigno_histo is null;
update siscolo.fatos_producao set lesoes_pre_neoplasico_histo=0 where lesoes_pre_neoplasico_histo is null;
update siscolo.fatos_producao set carcinomas_histo=0 where carcinomas_histo is null;   
update siscolo.fatos_producao set adenocarcinomas_histo=0 where adenocarcinomas_histo is null;
update siscolo.fatos_producao set nt_exam_histo=0 where nt_exam_histo is null;


