create table siscolo.cito_seguimento select id_, uid_,  C_RES_NORM, C_ATI_ESC, C_ATI_GLA, C_ATI_IND,
C_CEL_ESCA, C_GLA_ADEN,C_ID_IDAD, D_COL_US, C_COMP, D_LIBERA,faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.citologico;

ALTER TABLE `siscolo`.`cito_seguimento` 
ADD COLUMN `data_coleta` date AFTER `id_u_coleta`,
ADD COLUMN `data_liberacao` date AFTER `data_coleta`,
ADD COLUMN `cancer_lesao` varchar(1) AFTER `data_liberacao`,
ADD COLUMN `adenocarcinomas_cito` varchar(1) AFTER `cancer_lesao`,
ADD COLUMN `aoi` varchar(1) AFTER `adenocarcinomas_cito`,
ADD COLUMN `agc` varchar(1) AFTER `aoi`,
ADD COLUMN `asc_us` varchar(1) AFTER `agc`,
ADD COLUMN `asc_h` varchar(1) AFTER `asc_us`,
ADD COLUMN `lsil` varchar(1) AFTER `asc_h`,
ADD COLUMN `hsil` varchar(1) AFTER `lsil`,
ADD COLUMN `com_atipia` varchar(1) AFTER `hsil`,
ADD COLUMN `sem_atipia` varchar(1) AFTER `com_atipia`,
ADD COLUMN `f_baixo_risco` varchar(1) AFTER `sem_atipia`,
ADD COLUMN `f_alto_risco` varchar(1) AFTER `f_baixo_risco`,
ADD COLUMN `g_baixo_risco` varchar(1) AFTER `f_alto_risco`,
ADD COLUMN `g_alto_risco` varchar(1) AFTER `g_baixo_risco`,
ADD COLUMN `h_baixo_risco` varchar(1) AFTER `g_alto_risco`,
ADD COLUMN `h_alto_risco` varchar(1) AFTER `h_baixo_risco`,
ADD COLUMN `i_k_baixo_risco` varchar(1) AFTER `h_alto_risco`,
ADD COLUMN `i_k_alto_risco` varchar(1) AFTER `i_k_baixo_risco`,
ADD COLUMN `atipia_h` varchar(1) AFTER `i_k_alto_risco`,
ADD COLUMN `adeno_cancers` varchar(1) AFTER `atipia_h`,
ADD COLUMN `cancer_atipia_h` varchar(1) AFTER `adeno_cancers`;

update siscolo.cito_seguimento set data_liberacao = STR_TO_DATE(D_LIBERA,'%d/%m/%Y');
update siscolo.cito_seguimento set data_coleta = STR_TO_DATE(D_COL_US,'%d/%m/%Y');
update siscolo.cito_seguimento set cancer_lesao = '1' where C_CEL_ESCA = '3' or C_CEL_ESCA = '4';
update siscolo.cito_seguimento set aoi = '1' where C_ATI_IND = '1' or C_ATI_IND = '2';
update siscolo.cito_seguimento set agc = '1' where C_ATI_GLA = '1' or C_ATI_GLA = '2';
update siscolo.cito_seguimento set adenocarcinomas_cito = '1' where C_GLA_ADEN = '1' or C_GLA_ADEN = '2' or C_GLA_ADEN = '3' or C_GLA_ADEN = '4';
update siscolo.cito_seguimento set asc_us = '1' where C_ATI_ESC = '1';
update siscolo.cito_seguimento set asc_h = '1' where C_ATI_ESC = '2';
update siscolo.cito_seguimento set lsil = '1' where C_CEL_ESCA = '1';
update siscolo.cito_seguimento set hsil = '1' where C_CEL_ESCA = '2';

update siscolo.cito_seguimento set asc_us = '0' where asc_us='1' and agc='1';
update siscolo.cito_seguimento set asc_us = '0' where asc_us='1' and aoi='1';
update siscolo.cito_seguimento set asc_us = '0' where asc_us='1' and adenocarcinomas_cito = '1';
update siscolo.cito_seguimento set asc_h = '0' where agc='1' and asc_h='1';
update siscolo.cito_seguimento set aoi = '0' where asc_h='1' and aoi='1' ;
update siscolo.cito_seguimento set asc_h = '0' where asc_h='1' and adenocarcinomas_cito='1';
update siscolo.cito_seguimento set aoi = '0' where aoi='1' and agc='1' ;
update siscolo.cito_seguimento set lsil = '0' where lsil='1' and agc='1';
update siscolo.cito_seguimento set agc = '0' where agc='1' and hsil='1';
update siscolo.cito_seguimento set agc = '0' where agc='1' and cancer_lesao='1';
update siscolo.cito_seguimento set agc = '0' where agc='1' and adenocarcinomas_cito='1';
update siscolo.cito_seguimento set lsil = '0' where aoi='1' and lsil='1' ;
update siscolo.cito_seguimento set aoi = '0' where aoi='1' and adenocarcinomas_cito='1' ;
update siscolo.cito_seguimento set lsil = '0' where lsil='1' and adenocarcinomas_cito='1';
update siscolo.cito_seguimento set hsil = '0' where hsil='1' and adenocarcinomas_cito='1' ;
update siscolo.cito_seguimento set com_atipia= '1' where asc_us='1' or  asc_h='1' or agc='1' or aoi='1' or lsil='1' or hsil='1'or 
adenocarcinomas_cito ='1' or cancer_lesao = '1' ;
update siscolo.cito_seguimento set sem_atipia = '1' where com_atipia is null;
update siscolo.cito_seguimento set f_baixo_risco='1' where sem_atipia='1' or asc_us='1' or aoi='1' or agc='1' or lsil='1';
update siscolo.cito_seguimento set f_alto_risco='1' where asc_h='1' or hsil='1' or cancer_lesao='1' or adenocarcinomas_cito='1';
update siscolo.cito_seguimento set g_baixo_risco='1' where  sem_atipia='1' or lsil='1' or agc='1' or asc_us='1' or asc_h='1' or aoi='1';
update siscolo.cito_seguimento set g_alto_risco='1' where  hsil='1' or cancer_lesao='1' or adenocarcinomas_cito='1';
update siscolo.cito_seguimento set h_baixo_risco='1' where sem_atipia='1' or asc_us='1' or lsil='1';
update siscolo.cito_seguimento set h_alto_risco='1' where asc_h='1' or agc='1' or hsil='1' or cancer_lesao='1' or adenocarcinomas_cito='1';
update siscolo.cito_seguimento set i_k_baixo_risco ='1' where sem_atipia='1' or asc_us='1' or asc_h='1' or agc='1' or aoi='1' or lsil='1';
update siscolo.cito_seguimento set i_k_alto_risco ='1' where cancer_lesao='1' or adenocarcinomas_cito='1';
update siscolo.cito_seguimento set  atipia_h='1' where asc_h='1' or aoi='1' or agc='1' or hsil='1';
update siscolo.cito_seguimento set adeno_cancers='1' where adenocarcinomas_cito='1' or cancer_lesao = '1';
update siscolo.cito_seguimento set cancer_atipia_h='1' where adeno_cancers='1' or atipia_h='1';

ALTER TABLE `siscolo`.`cito_seguimento` 
CHANGE COLUMN `id_` `id_` INT(11) NOT NULL ,
ADD PRIMARY KEY (`id_`),
ADD INDEX `uid` (`uid_` ASC);

