# Create table histo_seguimento
create table siscolo.histo_seguimento select * from siscolo.histologico;

## The following steps are the preparation of the table histo_seguimento 

ALTER TABLE `siscolo`.`histo_seguimento` 
ADD COLUMN `data_coleta` date AFTER `adenocarcinomas_histo`,
ADD COLUMN `data_liberacao` date AFTER `data_coleta`,
ADD COLUMN `adeno_invasor` varchar(1) AFTER `data_liberacao`,
ADD COLUMN `carcinoma_invasor` varchar(1) AFTER `adeno_invasor`,
ADD COLUMN `carcinoma_microinvasor` varchar(1) AFTER `carcinoma_invasor`,
ADD COLUMN `nic_123` varchar(1) AFTER `carcinoma_microinvasor`,
ADD COLUMN `cancers` varchar(1) AFTER `nic_123`,
ADD COLUMN `cancers_histo` varchar(1) AFTER `cancers`,
ADD COLUMN `hist_negativa` varchar(1) AFTER `cancers_histo`,
ADD COLUMN `negativa_nic1` varchar(1) AFTER `hist_negativa`,
ADD COLUMN `nic_23` varchar(1) AFTER `negativa_nic1`,
ADD COLUMN `aden_cancer_histo` varchar(1) AFTER `nic_23`,
ADD COLUMN `g_aden_nic_23` varchar(1) AFTER `aden_cancer_histo`,
ADD COLUMN `g_cancer_invas` varchar(1) AFTER `g_aden_nic_23`,
ADD COLUMN `h_aden_can_nic` varchar(1) AFTER `g_cancer_invas`,
ADD COLUMN `m_com_invasao` varchar(1) AFTER `h_aden_can_nic`,
ADD COLUMN `m_sem_invasao` varchar(1) AFTER `m_com_invasao`,
ADD COLUMN `c_d_alto_risco` varchar(1) AFTER `m_sem_invasao`;

#m_com_invasao :Carcinoma epidermóide invasivo+Carcinoma epidermóide microinvasivo+Adenocarcinoma invasor
#m_sem_invasao: Adeno insitu+ NIC11/NICIII+Carcinoma epidermóide, impossível avaliar presença de nível de invasão
#Carcinoma_invasor:Carcinoma epidermóide invasivo, Adenocarcinoma invasor 
#carcinoma_microinvasor:Carcinoma epidermóide microinvasivo, Carcinoma epidermóide, impossível avaliar invasão, Adenocarcinoma in situ

update siscolo.histo_seguimento set data_liberacao = STR_TO_DATE(D_LIBERA,'%d/%m/%Y');
update siscolo.histo_seguimento set data_coleta = STR_TO_DATE(DANAEXAME,'%d/%m/%Y');
UPDATE siscolo.histo_seguimento set hist_negativa = '1' where C_BEN_META = "3" or C_BEN_POLI = "3" or
CBENSERVI = "3" or CBENALTER = "3";
update siscolo.histo_seguimento set adeno_invasor='1' where C_NEO_ADEN ='2' or C_NEO_ADEN ='3';

update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and CNEONICAR = '1';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and CNEONICAR = '2';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and CNEONICAR = '3';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and CNEONICAR = '4';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and CNEONICAR = '5';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and CNEONICAR = '6';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and CNEONICAR = '7';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and CNEONICAR = '8';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and C_NEO_ADEN= '1';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and C_NEO_ADEN= '2';
update siscolo.histo_seguimento set hist_negativa = '0' where hist_negativa = '1' and C_NEO_ADEN= '3';
update siscolo.histo_seguimento set CNEONICAR = '0' where CNEONICAR='2' and C_NEO_ADEN = '1';
update siscolo.histo_seguimento set CNEONICAR = '0' where CNEONICAR='3' and C_NEO_ADEN = '1';
update siscolo.histo_seguimento set CNEONICAR = '0' where CNEONICAR='3' and adeno_invasor = '1';
update siscolo.histo_seguimento set C_NEO_ADEN = '0' where CNEONICAR = '5'  and C_NEO_ADEN = '1';

###the required variables to follow-up women 

update siscolo.histo_seguimento set negativa_nic1='1' where hist_negativa = '1' or CNEONICAR = '1';
update siscolo.histo_seguimento set nic_123= '1' where CNEONICAR ='1' or CNEONICAR ='2' or CNEONICAR ='3';
update siscolo.histo_seguimento set nic_23= '1' where CNEONICAR ='2' or CNEONICAR ='3';
update siscolo.histo_seguimento set cancers = '1' where CNEONICAR ='4' or CNEONICAR ='5' or CNEONICAR ='6';
update siscolo.histo_seguimento set adenocarcinomas_histo = '1' where C_NEO_ADEN ='1' or C_NEO_ADEN ='2' or C_NEO_ADEN ='3';
update siscolo.histo_seguimento set aden_cancer_histo = '1' where adenocarcinomas_histo = '1' OR cancers = '1';
update siscolo.histo_seguimento set g_aden_nic_23 = '1' where nic_23= '1' or C_NEO_ADEN ='1';
update siscolo.histo_seguimento set g_cancer_invas ='1' where cancers = '1' or adeno_invasor = '1';
update siscolo.histo_seguimento set h_aden_can_nic ='1'  where nic_23= '1' or aden_cancer_histo = '1';
update siscolo.histo_seguimento set m_com_invasao='1' where CNEONICAR='4' or CNEONICAR='5' or adeno_invasor = '1';
update siscolo.histo_seguimento set m_sem_invasao='1' where CNEONICAR='6' or  nic_23= '1' or C_NEO_ADEN='1';
update siscolo.histo_seguimento set carcinoma_invasor = '1' where CNEONICAR ='5' or adeno_invasor='1';
update siscolo.histo_seguimento set carcinoma_microinvasor = '1' where CNEONICAR ='4' or CNEONICAR ='6' or C_NEO_ADEN ='1';
update siscolo.histo_seguimento set c_d_alto_risco ='1' WHERE CNEONICAR =2 OR CNEONICAR =3 OR aden_cancer_histo='1';

ALTER TABLE `siscolo`.`histo_seguimento` 
CHANGE COLUMN `id_` `id_` INT(11) NOT NULL ,
ADD PRIMARY KEY (`id_`),
ADD INDEX `uid` (`uid_` ASC);



