/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.uerj.lampada.siscolodw;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.ZoneId;
import static java.time.temporal.ChronoUnit.DAYS;
import java.util.Date;
import java.util.HashSet;
import java.util.Properties;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author sergio2
 */
public class IndicadoresLongitudinais {

    private Connection con;
    Properties props = new Properties();
    Set<Integer> idsFaixa = new HashSet<Integer>();
    Set<Integer> idsTempo = new HashSet<Integer>();
    Set<Integer> idsMunicipio = new HashSet<Integer>();
    Set<Integer> idsColeta = new HashSet<Integer>();
    Set<Integer> idsLaboratorio = new HashSet<Integer>();
    Set<Integer> uids = new HashSet<Integer>();

    public IndicadoresLongitudinais() {
        try {
            props.load(new FileInputStream("conexao.properties"));
        } catch (FileNotFoundException ex) {
            JOptionPane.showMessageDialog(null, "Não foi encontrado o arquivo de configuração da conexão");
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    private  Connection getDatabaseConnection(Properties props) {
        try {
            Connection con = null;
            Class.forName(props.getProperty("driver")).newInstance();
            con = DriverManager.getConnection(props.getProperty("url"),
                    props.getProperty("usuario"), props.getProperty("senha"));
            return con;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return null;
    }


    public static void main(String[] args) {
        IndicadoresLongitudinais indicador = new IndicadoresLongitudinais();
        indicador.geraIndicadorA();
        indicador.geraIndicadorB();
        indicador.geraIndicadorC();
        indicador.geraIndicadorD();
        indicador.geraIndicadorF();
        indicador.geraIndicadorG();
        indicador.geraIndicadorH();
        indicador.geraIndicadorI();
        indicador.geraIndicadorK();
        indicador.geraIndicadorL();
        indicador.geraIndicadorM();
    }

    public void geraIndicadorL() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            getIds("Select uid_ from siscolo.cito_seguimento where cancer_lesao = 1 and Year(data_liberacao) >= 2012 and Year(data_liberacao) < 2015", uids);
            String readCitoRecords = "select data_coleta, data_liberacao, cancer_lesao, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);

            String readHistoRecords = "select data_coleta, carcinoma_invasor, carcinoma_microinvasor, nic_23, negativa_nic1"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select LN1C, LN1H, LP1C2C1H, LT1C1H, LNnaoConduta, LTnaoConduta, LNcarcinomaInvasor, LNcarcinomaMicroinvasor, LNnic23, LNNic1Negativo "
                    + "from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (LN1C, LN1H, LP1C2C1H, LT1C1H, LNnaoConduta, LTnaoConduta, LNcarcinomaInvasor, LNcarcinomaMicroinvasor, LNnic23, LNNic1Negativo, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set LN1C = ?, LN1H = ?, LP1C2C1H = ?, LT1C1H = ?, LNnaoConduta = ?, LTnaoConduta = ?, LNcarcinomaInvasor = ?, LNcarcinomaMicroinvasor = ?, LNnic23 = ?, LNNic1Negativo = ?"
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);

            con.setAutoCommit(false);
            for (Integer uid : uids) {


                //obtem os registros de cada mulher com cancer_lesao, ordenada pela data de coleta
                /*               if (uid == 8570) {
                    System.out.println("estou aqui");
                }
                 */ boolean temOutroExame = false;
                boolean ano2014 = false;
                int intervaloHisto = -1;
                int carcinomaInvasor = 0;
                int nic23 = 0;
                int carcinomaMicroinvasor = 0;
                int lnNegativoNic1 = 0;
                int ln1h = 0;
                int ln1c = 0;
                int lnNaoConduta = 0;
                int lp1c2c1h = 0;
                int ltNaoConduta = -1;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                Date dataLiberacaoCito = null;
                LocalDate lcdataLiberacaoCito = null;
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int cancerLesao = rsCitoRecords.getInt("cancer_lesao");
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2014) && (cancerLesao == 1))) {
                    continue;
                }
                if (lcdataLiberacaoCito.getYear() == 2014) {
                    ano2014 = true;
                }
                // verifica se a mulher realizou exame histologico
                psReadHistoRecords.setInt(1, uid);
                ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                while (rsHistoRecords.next()) {
                    Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                    // compara datas
                    LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                    if (dataExameHisto.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloHisto = (int) DAYS.between(lcdataLiberacaoCito, lcdataExameHisto);
                        carcinomaInvasor = rsHistoRecords.getInt("carcinoma_invasor");
                        nic23 = rsHistoRecords.getInt("nic_23");
                        carcinomaMicroinvasor = rsHistoRecords.getInt("carcinoma_microinvasor");
                        lnNegativoNic1 = rsHistoRecords.getInt("negativa_nic1");
                        ln1h++;
                        temOutroExame = true;
                        break;
                    }
                }
                // caso não tenha exame histo, mas tenha um segundo cito
                if (ln1h == 0) {
                    while (rsCitoRecords.next()) {
                        Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                        LocalDate lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                        if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                            ltNaoConduta = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                            lnNaoConduta = 1;
                            temOutroExame = true;
                        }
                        break;
                    }
                }
                if (ano2014 && !temOutroExame) {
                    continue;
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                lp1c2c1h = 1 - Math.max(ln1h, lnNaoConduta);
                if (rs.next()) {
                    ln1c = rs.getInt("LN1C") + 1;
                    int intervaloAntigo = rs.getInt("LT1C1H");
                    if (intervaloHisto != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHisto = intervaloAntigo + intervaloHisto;
                        }
                    } else {
                        intervaloHisto = intervaloAntigo;
                    }
                    ln1h = rs.getInt("LN1H") + ln1h;
                    int carcinomaMicroinvasorNew = rs.getInt("LNcarcinomaMicroinvasor") + carcinomaMicroinvasor;
                    int nic23New = rs.getInt("LNnic23") + nic23;
                    int carcinomaInvasorNew = rs.getInt("LNcarcinomaInvasor") + carcinomaInvasor;
                    lp1c2c1h = rs.getInt("LP1C2C1H") + lp1c2c1h;
                    lnNegativoNic1 = rs.getInt("LNNic1Negativo") + lnNegativoNic1;
                    lnNaoConduta = rs.getInt("LNnaoConduta") + lnNaoConduta;
                    intervaloAntigo = rs.getInt("LTnaoConduta");
                    if (ltNaoConduta != -1) {
                        if (intervaloAntigo != -1) {
                            ltNaoConduta = intervaloAntigo + ltNaoConduta;
                        }
                    } else {
                        ltNaoConduta = intervaloAntigo;
                    }
                    psUpdateFact.setInt(1, ln1c);
                    psUpdateFact.setInt(2, ln1h);
                    psUpdateFact.setInt(3, lp1c2c1h);
                    psUpdateFact.setInt(4, intervaloHisto);
                    psUpdateFact.setInt(5, lnNaoConduta);
                    psUpdateFact.setInt(6, ltNaoConduta);
                    psUpdateFact.setInt(7, carcinomaInvasorNew);
                    psUpdateFact.setInt(8, carcinomaMicroinvasorNew);
                    psUpdateFact.setInt(9, nic23New);
                    psUpdateFact.setInt(10, lnNegativoNic1);
                    psUpdateFact.setInt(11, idTempo);
                    psUpdateFact.setInt(12, idFaixa);
                    psUpdateFact.setInt(13, idColeta);
                    psUpdateFact.setInt(14, idMunicipio);
                    psUpdateFact.setInt(15, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    ln1c = 1;
                    psInsertFact.setInt(1, ln1c);
                    psInsertFact.setInt(2, ln1h);
                    psInsertFact.setInt(3, lp1c2c1h);
                    psInsertFact.setInt(4, intervaloHisto);
                    psInsertFact.setInt(5, lnNaoConduta);
                    psInsertFact.setInt(6, ltNaoConduta);
                    psInsertFact.setInt(7, carcinomaInvasor);
                    psInsertFact.setInt(8, carcinomaMicroinvasor);
                    psInsertFact.setInt(9, nic23);
                    psInsertFact.setInt(10, lnNegativoNic1);
                    psInsertFact.setInt(11, idTempo);
                    psInsertFact.setInt(12, idFaixa);
                    psInsertFact.setInt(13, idColeta);
                    psInsertFact.setInt(14, idMunicipio);
                    psInsertFact.setInt(15, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorM() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where adenocarcinomas_cito = 1  and Year(data_liberacao) >= 2012 and Year(data_liberacao) < 2015", uids);
            /*            getDimensionIds("select id from siscolodw.tempo", idsTempo);
             getDimensionIds("select cnes from siscolodw.laboratorio", idsLaboratorio);
             getDimensionIds("select id from siscolodw.u_coleta", idsColeta);
             getDimensionIds("select codigo from siscolodw.municipio_residencia", idsMunicipio);
             */
            String readCitoRecords = "select data_coleta, data_liberacao, adenocarcinomas_cito, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);

            String readHistoRecords = "select data_coleta, m_sem_invasao, m_com_invasao, negativa_nic1"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select MN1C, MN1H, MP1C2C1H, MT1C1H, MnNaoConduta, MTnaoConduta, MNcomInvasao, MNsemInvasao, MNNic1Negativo "
                    + "from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (MN1C, MN1H, MP1C2C1H, MT1C1H, MNnaoConduta, MTnaoConduta, MNcomInvasao, MNsemInvasao, MNNic1Negativo, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set MN1C = ?, MN1H = ?, MP1C2C1H = ?, MT1C1H = ?, MNnaoConduta = ?, MTnaoConduta= ?, MNcomInvasao = ?, MNsemInvasao = ?, MNNic1Negativo = ? "
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {


                //obtem os registros de cada mulher com adenocarcinoma, ordenada pela data de coleta
                /*              if (uid == 93876) {
                    System.out.println("estou aqui");
                }
                 */ boolean temOutroExame = false;
                boolean ano2014 = false;
                int intervaloHisto = -1;
                int invasao = 0;
                int nic1Negativo = 0;
                int semInvasao = 0;
                int mn1h = 0;
                int mn1c = 1;
                int mnNaoConduta = 0;
                int mtNaoConduta = -1;
                int mp1c2c1h = 0;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito;
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                /*             if (idColeta == 322) {
                    System.out.println("estou aqui");
                }
                 */ dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int adenocarcinomasCito = rsCitoRecords.getInt("adenocarcinomas_cito");
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2014) && (adenocarcinomasCito == 1))) {
                    continue;
                }
                if (lcdataLiberacaoCito.getYear() == 2014) {
                    ano2014 = true;
                }
                // verifica se a mulher realizou exame histologico
                psReadHistoRecords.setInt(1, uid);
                ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                while (rsHistoRecords.next()) {
                    Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                    // compara datas
                    LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                    if (dataExameHisto.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloHisto = (int) DAYS.between(lcdataLiberacaoCito, lcdataExameHisto);
                        invasao = rsHistoRecords.getInt("m_com_invasao");
                        nic1Negativo = rsHistoRecords.getInt("negativa_nic1");
                        semInvasao = rsHistoRecords.getInt("m_sem_invasao");
                        mn1h++;
                        temOutroExame = true;
                        break;
                    }
                }
                // caso não tenha exame histo, mas tenha um segundo cito
                if (mn1h == 0) {
                    while (rsCitoRecords.next()) {
                        Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                        LocalDate lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                        if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                            mtNaoConduta = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                            mnNaoConduta = 1;
                            temOutroExame = true;
                        }
                        break;
                    }
                }

                if (ano2014 && !temOutroExame) {
                    continue;
                }
                mp1c2c1h = 1 - Math.max(mn1h, mnNaoConduta);
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                if (rs.next()) {
                    mn1c = rs.getInt("MN1C") + 1;
                    int intervaloAntigo = rs.getInt("MT1C1H");
                    if (intervaloHisto != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHisto = intervaloAntigo + intervaloHisto;
                        }
                    } else {
                        intervaloHisto = intervaloAntigo;
                    }
                    mn1h = rs.getInt("MN1H") + mn1h;
                    mp1c2c1h = rs.getInt("MP1C2C1H") + mp1c2c1h;
                    invasao = rs.getInt("MNcomInvasao") + invasao;
                    nic1Negativo = rs.getInt("MNNic1Negativo") + nic1Negativo;
                    semInvasao = rs.getInt("MNsemInvasao") + semInvasao;
                    mnNaoConduta = rs.getInt("MNNaoConduta") + mnNaoConduta;
                    intervaloAntigo = rs.getInt("MTnaoConduta");
                    if (mtNaoConduta != -1) {
                        if (intervaloAntigo != -1) {
                            mtNaoConduta = intervaloAntigo + mtNaoConduta;
                        }
                    } else {
                        mtNaoConduta = intervaloAntigo;
                    }
                    psUpdateFact.setInt(1, mn1c);
                    psUpdateFact.setInt(2, mn1h);
                    psUpdateFact.setInt(3, mp1c2c1h);
                    psUpdateFact.setInt(4, intervaloHisto);
                    psUpdateFact.setInt(5, mnNaoConduta);
                    psUpdateFact.setInt(6, mtNaoConduta);
                    psUpdateFact.setInt(7, invasao);
                    psUpdateFact.setInt(8, semInvasao);
                    psUpdateFact.setInt(9, nic1Negativo);
                    psUpdateFact.setInt(10, idTempo);
                    psUpdateFact.setInt(11, idFaixa);
                    psUpdateFact.setInt(12, idColeta);
                    psUpdateFact.setInt(13, idMunicipio);
                    psUpdateFact.setInt(14, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, mn1c);
                    psInsertFact.setInt(2, mn1h);
                    psInsertFact.setInt(3, mp1c2c1h);
                    psInsertFact.setInt(4, intervaloHisto);
                    psInsertFact.setInt(5, mnNaoConduta);
                    psInsertFact.setInt(6, mtNaoConduta);
                    psInsertFact.setInt(7, invasao);
                    psInsertFact.setInt(8, semInvasao);
                    psInsertFact.setInt(9, nic1Negativo);
                    psInsertFact.setInt(10, idTempo);
                    psInsertFact.setInt(11, idFaixa);
                    psInsertFact.setInt(12, idColeta);
                    psInsertFact.setInt(13, idMunicipio);
                    psInsertFact.setInt(14, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorF() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where asc_h = 1 and Year(data_liberacao) >= 2012 and Year(data_liberacao) < 2015 ", uids);
            /*            getDimensionIds("select id from siscolodw.tempo", idsTempo);
             getDimensionIds("select cnes from siscolodw.laboratorio", idsLaboratorio);
             getDimensionIds("select id from siscolodw.u_coleta", idsColeta);
             getDimensionIds("select codigo from siscolodw.municipio_residencia", idsMunicipio);
             */
            String readCitoRecords = "select data_coleta, data_liberacao, f_alto_risco, asc_h, f_baixo_risco, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);
            String readHistoRecords = "select data_coleta, nic_23, aden_cancer_histo, negativa_nic1, data_liberacao"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select FN1C, FN1H, FP1C2C1H, FT1C2C, FT1C1H, FNNic1Negativo, FNnic23, FNCancer, FN2C, FNbaixoRisco, FNaltoRisco, "
                    + "FN3Ca, FP2C3Ca, FT2C3Ca, FN2Cb, FP1H2Cb, FT1H2Cb"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (FN1C, FN1H, FP1C2C1H, FT1C2C, FT1C1H, FNNic1Negativo, FNnic23, FNCancer, FN2C, FNbaixoRisco, FNaltoRisco, "
                    + "FN3Ca, FP2C3Ca, FT2C3Ca, FN2Cb, FP1H2Cb, FT1H2Cb, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set FN1C = ?, FN1H = ?, FP1C2C1H = ?, FT1C2C = ?, FT1C1H = ?, FNNic1Negativo = ?, FNnic23 = ?, FNCancer = ?, FN2C = ?, "
                    + "FNbaixoRisco = ?, FNaltoRisco = ?, FN3Ca = ?, FP2C3Ca= ?, FT2C3Ca = ?, FN2Cb = ?, FP1H2Cb = ?, FT1H2Cb = ?"
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";

            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                boolean temOutroExame = false;
                boolean exameHisto = false;
                boolean ano2014 = false;
                int cancer = 0;
                int nic23 = 0;
                int fn1h = 0;
                int fn1c = 1;
                int fp1c2c1h = 0;
                int fn2c = 0;
                int fn3ca = 0;
                int fn2cb = 0;
                int fp2c3ca = 0;
                int fp1h2cb = 0;
                int fnNegativoNic1 = 0;
                int fnBaixoRisco = 0;
                int fnAltoRisco = 0;
                int intervaloCito1Cito2 = -1;
                int intervaloCito2Cito3a = -1;
                int intervaloCito1Histo = -1;
                int intervaloHistoCito2 = -1;
                Date dataLiberacaoCito2 = null;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito, lcdataLiberacaoCito2 = null;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int ascH = rsCitoRecords.getInt("asc_h");
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2014) && (ascH == 1))) {
                    continue;
                }
                fn1c = 1;
                if (lcdataLiberacaoCito.getYear() == 2014) {
                    ano2014 = true;
                }
                // verifica se a mulher realizou exame histologico
                psReadHistoRecords.setInt(1, uid);
                ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                while (rsHistoRecords.next()) {
                    Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                    LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                    Date dataLiberacaoHisto = rsHistoRecords.getDate("data_liberacao");
                    LocalDate lcdataLiberacaoHisto = IndicadoresLongitudinais.toLocalDate(dataLiberacaoHisto);
                    int intervalo = (int) DAYS.between(lcdataLiberacaoCito, lcdataExameHisto);
                    if (dataExameHisto.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloCito1Histo = intervalo;
                        cancer = rsHistoRecords.getInt("aden_cancer_histo");
                        nic23 = rsHistoRecords.getInt("nic_23");
                        fnNegativoNic1 = rsHistoRecords.getInt("negativa_nic1");
                        fn1h++;
                        exameHisto = true;
                        temOutroExame = true;
                        rsHistoRecords.close();
                        if (fnNegativoNic1 == 1) {
                            fp1h2cb = 1;
                            while (rsCitoRecords.next()) {
                                Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                                lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                                if (dataColetaCito2.compareTo(dataLiberacaoHisto) >= 0) {
                                    intervaloHistoCito2 = (int) DAYS.between(lcdataLiberacaoHisto, lcdataColetaCito2);
                                    fp1h2cb = 0;
                                    fn2cb = 1;
                                    break;
                                }
                            }
                        }
                    }
                    break;
                }
                // segundo cito
                if (!exameHisto) {
                    if (rsCitoRecords.next()) {
                        Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                        dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                        lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                        lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                        if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                            intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                            temOutroExame = true;
                            fn2c = 1;
                            fnAltoRisco = rsCitoRecords.getInt("f_alto_risco");
                            fnBaixoRisco = rsCitoRecords.getInt("f_baixo_risco");
                            if (fnBaixoRisco == 1) {
                                fp2c3ca = 1;
                                if (rsCitoRecords.next()) {
                                    Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                    LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                    if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                        intervaloCito2Cito3a = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                        fn3ca = 1;
                                        fp2c3ca = 0;
                                    }
                                }
                            }
                        }
                    }
                }
                if (ano2014 && !temOutroExame) {
                    continue;
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                if ((fn2c == 1) || (fn1h == 1)) {
                    fp1c2c1h = 0;
                } else {
                    fp1c2c1h = 1;
                }
                if (rs.next()) {
                    fn1c = rs.getInt("FN1C") + 1;
                    fp1c2c1h = rs.getInt("FP1C2C1H") + fp1c2c1h;
                    int intervaloAntigo = rs.getInt("FT1C1H");
                    if (intervaloCito1Histo != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Histo = intervaloAntigo + intervaloCito1Histo;
                        }
                    } else {
                        intervaloCito1Histo = intervaloAntigo;
                    }
                    fn1h = rs.getInt("FN1H") + fn1h;
                    intervaloAntigo = rs.getInt("FT2C3Ca");
                    if (intervaloCito2Cito3a != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3a = intervaloAntigo + intervaloCito2Cito3a;
                        }
                    } else {
                        intervaloCito2Cito3a = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("FT1H2Cb");
                    if (intervaloHistoCito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHistoCito2 = intervaloAntigo + intervaloHistoCito2;
                        }
                    } else {
                        intervaloHistoCito2 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("FT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    cancer = rs.getInt("FNcancer") + cancer;
                    nic23 = rs.getInt("FNnic23") + nic23;
                    fn2c = fn2c + rs.getInt("FN2C");
                    fnNegativoNic1 = rs.getInt("FNNic1Negativo") + fnNegativoNic1;
                    fnBaixoRisco = rs.getInt("FNbaixoRisco") + fnBaixoRisco;
                    fnAltoRisco = rs.getInt("FNaltoRisco") + fnAltoRisco;
                    fn3ca = rs.getInt("FN3Ca") + fn3ca;
                    fp2c3ca = rs.getInt("FP2C3Ca") + fp2c3ca;
                    fn2cb = rs.getInt("FN2Cb") + fn2cb;
                    fp1h2cb = rs.getInt("FP1H2Cb") + fp1h2cb;
                    psUpdateFact.setInt(1, fn1c);
                    psUpdateFact.setInt(2, fn1h);
                    psUpdateFact.setInt(3, fp1c2c1h);
                    psUpdateFact.setInt(4, intervaloCito1Cito2);
                    psUpdateFact.setInt(5, (int) intervaloCito1Histo);
                    psUpdateFact.setInt(6, fnNegativoNic1);
                    psUpdateFact.setInt(7, nic23);
                    psUpdateFact.setInt(8, cancer);
                    psUpdateFact.setInt(9, fn2c);
                    psUpdateFact.setInt(10, fnBaixoRisco);
                    psUpdateFact.setInt(11, fnAltoRisco);
                    psUpdateFact.setInt(12, fn3ca);
                    psUpdateFact.setInt(13, fp2c3ca);
                    psUpdateFact.setInt(14, intervaloCito2Cito3a);
                    psUpdateFact.setInt(15, fn2cb);
                    psUpdateFact.setInt(16, fp1h2cb);
                    psUpdateFact.setInt(17, intervaloHistoCito2);
                    psUpdateFact.setInt(18, idTempo);
                    psUpdateFact.setInt(19, idFaixa);
                    psUpdateFact.setInt(20, idColeta);
                    psUpdateFact.setInt(21, idMunicipio);
                    psUpdateFact.setInt(22, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, fn1c);
                    psInsertFact.setInt(2, fn1h);
                    psInsertFact.setInt(3, fp1c2c1h);
                    psInsertFact.setInt(4, intervaloCito1Cito2);
                    psInsertFact.setInt(5, (int) intervaloCito1Histo);
                    psInsertFact.setInt(6, fnNegativoNic1);
                    psInsertFact.setInt(7, nic23);
                    psInsertFact.setInt(8, cancer);
                    psInsertFact.setInt(9, fn2c);
                    psInsertFact.setInt(10, fnBaixoRisco);
                    psInsertFact.setInt(11, fnAltoRisco);
                    psInsertFact.setInt(12, fn3ca);
                    psInsertFact.setInt(13, fp2c3ca);
                    psInsertFact.setInt(14, intervaloCito2Cito3a);
                    psInsertFact.setInt(15, fn2cb);
                    psInsertFact.setInt(16, fp1h2cb);
                    psInsertFact.setInt(17, intervaloHistoCito2);
                    psInsertFact.setInt(18, idTempo);
                    psInsertFact.setInt(19, idFaixa);
                    psInsertFact.setInt(20, idColeta);
                    psInsertFact.setInt(21, idMunicipio);
                    psInsertFact.setInt(22, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    private void getIds(String readString, Set<Integer> ids) throws SQLException {
        PreparedStatement psReadDim = con.prepareStatement(readString);
        ResultSet rsIds = psReadDim.executeQuery();
        while (rsIds.next()) {
            ids.add(rsIds.getInt(1));
        }
        rsIds.close();
        psReadDim.close();
    }

    /**
     * Converte Date para LocalDate
     *
     * @param d
     * @return LocalDate
     */
    public static LocalDate toLocalDate(Date d) {
        Instant instant = Instant.ofEpochMilli(d.getTime());
        LocalDate localDate = LocalDateTime.ofInstant(instant, ZoneId.systemDefault()).toLocalDate();
        return localDate;
    }

    public void geraIndicadorG() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where agc = 1 and Year(data_liberacao) >= 2012 and Year(data_liberacao) < 2015", uids);
            String readCitoRecords = "select data_coleta, data_liberacao, g_alto_risco, agc, g_baixo_risco, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);

            String readHistoRecords = "select data_coleta, data_liberacao, negativa_nic1, g_aden_nic_23, g_cancer_invas"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select GN1C, GN1H, GP1C2C1H, GT1C2C, GT1C1H, GNNic1Negativo, GNadenoCancer, GNnic23, GN2C, GNbaixoRisco, GNaltoRisco, "
                    + "GN3C, GP2C3C, GT2C3C, GN2Cb, GP1H2Cb, GT1H2Cb"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (GN1C, GN1H, GP1C2C1H, GT1C2C, GT1C1H, GNNic1Negativo, GNadenoCancer, GNnic23, GN2C, GNbaixoRisco, GNaltoRisco, "
                    + "GN3C, GP2C3C, GT2C3C, GN2Cb, GP1H2Cb, GT1H2Cb, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set GN1C = ?, GN1H = ?, GP1C2C1H = ?, GT1C2C = ?, GT1C1H = ?, GNNic1Negativo = ?, GNadenoCancer = ?, GNnic23 = ?, GN2C = ?, "
                    + "GNbaixoRisco = ?, GNaltoRisco = ?, GN3C = ?, GP2C3C= ?, GT2C3C = ?, GN2Cb = ?, GP1H2Cb = ?, GT1H2Cb = ?"
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";

            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                boolean temOutroExame = false;
                boolean ano2014 = false;
                boolean exameHisto = false;
                int intervaloCito1Histo = -1;
                int adenoCancer = 0;
                int nic1Negativo = 0;
                int nic23 = 0;
                int gn1h = 0;
                int gn1c = 1;
                int gp1c2c1h = 0;
                int gn2c = 0;
                int gn3c = 0;
                int gn2cb = 0;
                int gp2c3c = 0;
                int gp1h2c = 0;
                int gnBaixoRisco = 0;
                int gnAltoRisco = 0;
                int intervaloCito1Cito2 = -1;
                int intervaloCito2Cito3 = -1;
                int intervaloHistoCito2 = -1;
                Date dataLiberacaoCito2 = null;
                boolean segundoCito = false;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito, lcdataLiberacaoCito2 = null;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int agc = rsCitoRecords.getInt("agc");
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2014) && (agc == 1))) {
                    continue;
                }
                gn1c = 1;
                if (lcdataLiberacaoCito.getYear() == 2014) {
                    ano2014 = true;
                }
                // verifica se a mulher realizou exame histologico
                psReadHistoRecords.setInt(1, uid);
                ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                while (rsHistoRecords.next()) {
                    Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                    Date dataLiberacaoHisto = rsHistoRecords.getDate("data_liberacao");
                    // compara datas
                    LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                    LocalDate lcdataLiberacaoHisto = IndicadoresLongitudinais.toLocalDate(dataLiberacaoHisto);
                    int intervalo = (int) DAYS.between(lcdataLiberacaoCito, lcdataExameHisto);
                    if (dataExameHisto.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloCito1Histo = intervalo;
                        adenoCancer = rsHistoRecords.getInt("g_cancer_invas");
                        nic1Negativo = rsHistoRecords.getInt("negativa_nic1");
                        nic23 = rsHistoRecords.getInt("g_aden_nic_23");
                        if (nic1Negativo == 1) {
                            gp1h2c = 1;
                            while (rsCitoRecords.next()) {
                                Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                                lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                                if (dataColetaCito2.compareTo(dataLiberacaoHisto) >= 0) {
                                    intervaloHistoCito2 = (int) DAYS.between(lcdataLiberacaoHisto, lcdataColetaCito2);
                                    gn2cb = 1;
                                    gp1h2c = 0;
                                    break;
                                }
                            }
                        }
                        gn1h++;
                        exameHisto = true;
                        temOutroExame = true;
                        rsHistoRecords.close();
                        break;
                    }
                }
                // segundo cito
                if (!exameHisto) {
                    if (rsCitoRecords.next()) {
                        Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                        dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                        lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                        lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                        if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                            intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                            segundoCito = true;
                            temOutroExame = true;
                        }
                    }
                    if (segundoCito) {
                        gn2c = 1;
                        gnBaixoRisco = rsCitoRecords.getInt("g_baixo_risco");
                        gnAltoRisco = rsCitoRecords.getInt("g_alto_risco");
                        if (gnBaixoRisco == 1) {
                            gp2c3c = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3 = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    gn3c = 1;
                                    gp2c3c = 0;
                                }
                            }
                        }
                    }
                }
                if (ano2014 && !temOutroExame) {
                    continue;
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                if ((gn2c == 1) || (gn1h == 1)) {
                    gp1c2c1h = 0;
                } else {
                    gp1c2c1h = 1;
                }
                if (rs.next()) {
                    gn1c = rs.getInt("GN1C") + 1;
                    gp1c2c1h = rs.getInt("GP1C2C1H") + gp1c2c1h;
                    int intervaloAntigo = rs.getInt("GT1C1H");
                    if (intervaloCito1Histo != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Histo = intervaloAntigo + intervaloCito1Histo;
                        }
                    } else {
                        intervaloCito1Histo = intervaloAntigo;
                    }
                    gn1h = rs.getInt("GN1H") + gn1h;
                    intervaloAntigo = rs.getInt("GT1H2Cb");
                    if (intervaloHistoCito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHistoCito2 = intervaloAntigo + intervaloHistoCito2;
                        }
                    } else {
                        intervaloHistoCito2 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("GT2C3C");
                    if (intervaloCito2Cito3 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3 = intervaloAntigo + intervaloCito2Cito3;
                        }
                    } else {
                        intervaloCito2Cito3 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("GT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    adenoCancer = rs.getInt("GNadenoCancer") + adenoCancer;
                    nic1Negativo = rs.getInt("GNNic1Negativo") + nic1Negativo;
                    nic23 = rs.getInt("GNnic23") + nic23;
                    gnAltoRisco = rs.getInt("GNaltoRisco") + gnAltoRisco;
                    gnBaixoRisco = rs.getInt("GNbaixoRisco") + gnBaixoRisco;
                    gn2c = gn2c + rs.getInt("GN2C");
                    gn3c = rs.getInt("GN3C") + gn3c;
                    gp2c3c = rs.getInt("GP2C3C") + gp2c3c;
                    gn2cb = rs.getInt("GN2Cb") + gn2cb;
                    gp1h2c = rs.getInt("GP1H2Cb") + gp1h2c;
                    psUpdateFact.setInt(1, gn1c);
                    psUpdateFact.setInt(2, gn1h);
                    psUpdateFact.setInt(3, gp1c2c1h);
                    psUpdateFact.setInt(4, intervaloCito1Cito2);
                    psUpdateFact.setInt(5, intervaloCito1Histo);
                    psUpdateFact.setInt(6, nic1Negativo);
                    psUpdateFact.setInt(7, adenoCancer);
                    psUpdateFact.setInt(8, nic23);
                    psUpdateFact.setInt(9, gn2c);
                    psUpdateFact.setInt(10, gnBaixoRisco);
                    psUpdateFact.setInt(11, gnAltoRisco);
                    psUpdateFact.setInt(12, gn3c);
                    psUpdateFact.setInt(13, gp2c3c);
                    psUpdateFact.setInt(14, intervaloCito2Cito3);
                    psUpdateFact.setInt(15, gn2cb);
                    psUpdateFact.setInt(16, gp1h2c);
                    psUpdateFact.setInt(17, intervaloHistoCito2);
                    psUpdateFact.setInt(18, idTempo);
                    psUpdateFact.setInt(19, idFaixa);
                    psUpdateFact.setInt(20, idColeta);
                    psUpdateFact.setInt(21, idMunicipio);
                    psUpdateFact.setInt(22, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, gn1c);
                    psInsertFact.setInt(2, gn1h);
                    psInsertFact.setInt(3, gp1c2c1h);
                    psInsertFact.setInt(4, intervaloCito1Cito2);
                    psInsertFact.setInt(5, intervaloCito1Histo);
                    psInsertFact.setInt(6, nic1Negativo);
                    psInsertFact.setInt(7, adenoCancer);
                    psInsertFact.setInt(8, nic23);
                    psInsertFact.setInt(9, gn2c);
                    psInsertFact.setInt(10, gnBaixoRisco);
                    psInsertFact.setInt(11, gnAltoRisco);
                    psInsertFact.setInt(12, gn3c);
                    psInsertFact.setInt(13, gp2c3c);
                    psInsertFact.setInt(14, intervaloCito2Cito3);
                    psInsertFact.setInt(15, gn2cb);
                    psInsertFact.setInt(16, gp1h2c);
                    psInsertFact.setInt(17, intervaloHistoCito2);
                    psInsertFact.setInt(18, idTempo);
                    psInsertFact.setInt(19, idFaixa);
                    psInsertFact.setInt(20, idColeta);
                    psInsertFact.setInt(21, idMunicipio);
                    psInsertFact.setInt(22, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorI() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where hsil = 1 and C_ID_IDAD >= 25 and Year(data_liberacao) >= 2012 and Year(data_liberacao) < 2015", uids);
            /*            getDimensionIds("select id from siscolodw.tempo", idsTempo);
             getDimensionIds("select cnes from siscolodw.laboratorio", idsLaboratorio);
             getDimensionIds("select id from siscolodw.u_coleta", idsColeta);
             getDimensionIds("select codigo from siscolodw.municipio_residencia", idsMunicipio);
             */
            String readCitoRecords = "select data_coleta, data_liberacao, i_k_alto_risco, hsil, i_k_baixo_risco, C_ID_IDAD, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);

            String readHistoRecords = "select data_coleta, data_liberacao, nic_23, negativa_nic1, aden_cancer_histo"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select IN1C, IN1H, IP1C2C1H, IT1C2C, IT1C1H, INNic1Negativo, INnic23, INadenoCancer, IN2C, INbaixoRisco, INhsil, INaltoRisco, "
                    + "IN3C, IP2C3C, IT2C3C, IN2Cb, IP1H2Cb, IT1H2Cb"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (IN1C, IN1H, IP1C2C1H, IT1C2C, IT1C1H, INNic1Negativo, INnic23, INadenoCancer, IN2C, INbaixoRisco, INhsil, INaltoRisco, "
                    + "IN3C, IP2C3C, IT2C3C, IN2Cb, IP1H2Cb, IT1H2Cb, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set IN1C = ?, IN1H = ?, IP1C2C1H = ?, IT1C2C = ?, IT1C1H = ?, INNic1Negativo = ?, INnic23 = ?, INadenoCancer = ?, IN2C = ?, "
                    + "INbaixoRisco = ?, INhsil = ?, INaltoRisco = ?, IN3C = ?, IP2C3C= ?, IT2C3C = ?, IN2Cb = ?, IP1H2Cb = ?, IT1H2Cb = ?"
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";

            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                boolean temOutroExame = false;
                boolean ano2014 = false;
                boolean exameHisto = false;
                int intervaloHisto = -1;
                int adenoCancer = 0;
                int nic1Negativo = 0;
                int nic23 = 0;
                int in1h = 0;
                int in1c = 1;
                int ip1c2c1h = 0;
                int in2c = 0;
                int in3c = 0;
                int in2cb = 0;
                int ip2c3c = 0;
                int inBaixoRisco = 0;
                int ip1h2c = 0;
                int inAltoRisco = 0;
                int inhsil = 0;
                int intervaloCito1Cito2 = -1;
                int intervaloCito2Cito3 = -1;
                int intervaloHistoCito2 = -1;
                Date dataLiberacaoCito2 = null;
                boolean segundoCito = false;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito, lcdataLiberacaoCito2 = null;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int idade = rsCitoRecords.getInt("C_ID_IDAD");
                int hsil = rsCitoRecords.getInt("hsil");
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2014) && (hsil == 1) && (idade >= 25))) {
                    continue;
                }
                if (lcdataLiberacaoCito.getYear() == 2014) {
                    ano2014 = true;
                }
                // verifica se a mulher realizou exame histologico
                psReadHistoRecords.setInt(1, uid);
                ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                while (rsHistoRecords.next()) {
                    Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                    Date dataLiberacaoHisto = rsHistoRecords.getDate("data_liberacao");
                    // compara datas
                    LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                    LocalDate lcdataLiberacaoHisto = IndicadoresLongitudinais.toLocalDate(dataLiberacaoHisto);
                    int intervalo = (int) DAYS.between(lcdataLiberacaoCito, lcdataExameHisto);
                    if (dataExameHisto.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloHisto = intervalo;
                        nic23 = rsHistoRecords.getInt("nic_23");
                        adenoCancer = rsHistoRecords.getInt("aden_cancer_histo");
                        nic1Negativo = rsHistoRecords.getInt("negativa_nic1");
                        if (nic1Negativo == 1) {
                            ip1h2c = 1;
                            while (rsCitoRecords.next()) {
                                Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                                lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                                if (dataColetaCito2.compareTo(dataLiberacaoHisto) >= 0) {
                                    intervaloHistoCito2 = (int) DAYS.between(lcdataLiberacaoHisto, lcdataColetaCito2);
                                    in2cb = 1;
                                    ip1h2c = 0;
                                    break;
                                }
                            }
                        }
                        in1h++;
                        exameHisto = true;
                        temOutroExame = true;
                        rsHistoRecords.close();
                        break;
                    }
                }
                // segundo cito
                if (!exameHisto) {
                    if (rsCitoRecords.next()) {
                        Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                        dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                        lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                        lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                        if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                            intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                            segundoCito = true;
                            temOutroExame = true;
                        }
                    }
                    if (segundoCito) {
                        in2c = 1;
                        inhsil = rsCitoRecords.getInt("hsil");
                        inBaixoRisco = rsCitoRecords.getInt("i_k_baixo_risco");
                        inAltoRisco = rsCitoRecords.getInt("i_k_alto_risco");
                        if (inBaixoRisco == 1) {
                            ip2c3c = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3 = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    in3c = 1;
                                    ip2c3c = 0;
                                }
                            }
                        }
                    }
                }
                if (ano2014 && !temOutroExame) {
                    continue;
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                ip1c2c1h = in1c - Math.max(in2c, in1h);
                if (rs.next()) {
                    in1c = rs.getInt("IN1C") + 1;
                    ip1c2c1h = rs.getInt("IP1C2C1H") + ip1c2c1h;
                    int intervaloAntigo = rs.getInt("IT1C1H");
                    if (intervaloHisto != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHisto = intervaloAntigo + intervaloHisto;
                        }
                    } else {
                        intervaloHisto = intervaloAntigo;
                    }
                    in1h = rs.getInt("IN1H") + in1h;
                    intervaloAntigo = rs.getInt("IT1H2Cb");
                    if (intervaloHistoCito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHistoCito2 = intervaloAntigo + intervaloHistoCito2;
                        }
                    } else {
                        intervaloHistoCito2 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("IT2C3C");
                    if (intervaloCito2Cito3 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3 = intervaloAntigo + intervaloCito2Cito3;
                        }
                    } else {
                        intervaloCito2Cito3 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("IT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    adenoCancer = rs.getInt("INadenoCancer") + adenoCancer;
                    nic1Negativo = rs.getInt("INNic1Negativo") + nic1Negativo;
                    nic23 = rs.getInt("INnic23") + nic23;
                    in2c = in2c + rs.getInt("IN2C");
                    inAltoRisco = rs.getInt("INaltoRisco") + inAltoRisco;
                    inBaixoRisco = rs.getInt("INbaixoRisco") + inBaixoRisco;
                    inhsil = rs.getInt("INhsil") + inhsil;
                    in3c = rs.getInt("IN3C") + in3c;
                    ip2c3c = rs.getInt("IP2C3C") + ip2c3c;
                    in2cb = rs.getInt("IN2Cb") + in2cb;
                    ip1h2c = rs.getInt("IP1H2Cb") + ip1h2c;
                    psUpdateFact.setInt(1, in1c);
                    psUpdateFact.setInt(2, in1h);
                    psUpdateFact.setInt(3, ip1c2c1h);
                    psUpdateFact.setInt(4, intervaloCito1Cito2);
                    psUpdateFact.setInt(5, intervaloHisto);
                    psUpdateFact.setInt(6, nic1Negativo);
                    psUpdateFact.setInt(7, nic23);
                    psUpdateFact.setInt(8, adenoCancer);
                    psUpdateFact.setInt(9, in2c);
                    psUpdateFact.setInt(10, inBaixoRisco);
                    psUpdateFact.setInt(11, inhsil);
                    psUpdateFact.setInt(12, inAltoRisco);
                    psUpdateFact.setInt(13, in3c);
                    psUpdateFact.setInt(14, ip2c3c);
                    psUpdateFact.setInt(15, intervaloCito2Cito3);
                    psUpdateFact.setInt(16, in2cb);
                    psUpdateFact.setInt(17, ip1h2c);
                    psUpdateFact.setInt(18, intervaloHistoCito2);
                    psUpdateFact.setInt(19, idTempo);
                    psUpdateFact.setInt(20, idFaixa);
                    psUpdateFact.setInt(21, idColeta);
                    psUpdateFact.setInt(22, idMunicipio);
                    psUpdateFact.setInt(23, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, in1c);
                    psInsertFact.setInt(2, in1h);
                    psInsertFact.setInt(3, ip1c2c1h);
                    psInsertFact.setInt(4, intervaloCito1Cito2);
                    psInsertFact.setInt(5, intervaloHisto);
                    psInsertFact.setInt(6, nic1Negativo);
                    psInsertFact.setInt(7, nic23);
                    psInsertFact.setInt(8, adenoCancer);
                    psInsertFact.setInt(9, in2c);
                    psInsertFact.setInt(10, inBaixoRisco);
                    psInsertFact.setInt(11, inhsil);
                    psInsertFact.setInt(12, inAltoRisco);
                    psInsertFact.setInt(13, in3c);
                    psInsertFact.setInt(14, ip2c3c);
                    psInsertFact.setInt(15, intervaloCito2Cito3);
                    psInsertFact.setInt(16, in2cb);
                    psInsertFact.setInt(17, ip1h2c);
                    psInsertFact.setInt(18, intervaloHistoCito2);
                    psInsertFact.setInt(19, idTempo);
                    psInsertFact.setInt(20, idFaixa);
                    psInsertFact.setInt(21, idColeta);
                    psInsertFact.setInt(22, idMunicipio);
                    psInsertFact.setInt(23, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorK() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where hsil = 1 and C_ID_IDAD < 25 and Year(data_liberacao) >= 2012 and Year(data_liberacao) < 2015", uids);
            /*            getDimensionIds("select id from siscolodw.tempo", idsTempo);
             getDimensionIds("select cnes from siscolodw.laboratorio", idsLaboratorio);
             getDimensionIds("select id from siscolodw.u_coleta", idsColeta);
             getDimensionIds("select codigo from siscolodw.municipio_residencia", idsMunicipio);
             */
            String readCitoRecords = "select data_coleta, data_liberacao, i_k_alto_risco, hsil, i_k_baixo_risco, C_ID_IDAD, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);

            String readHistoRecords = "select data_coleta, data_liberacao, negativa_nic1, aden_cancer_histo, nic_23"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select KN1C, KN1H, KP1C2C1H, KT1C2C, KT1C1H, KNNic1Negativo, KNnic23, KNadenoCancer, KN2C, KNbaixoRisco, KNhsil, KNaltoRisco, "
                    + "KN3Ca, KP2C3Ca, KT2C3Ca, KN3Cb, KP2C3Cb, KT2C3Cb, KN2Cb, KP1H2Cb, KT1H2Cb, KN2Cc, KP1H2Cc, KT1H2Cc"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (KN1C, KN1H, KP1C2C1H, KT1C2C, KT1C1H, KNNic1Negativo, KNnic23, KNadenoCancer, KN2C, KNbaixoRisco, KNhsil, KNaltoRisco, "
                    + "KN3Ca, KP2C3Ca, KT2C3Ca, KN3Cb, KP2C3Cb, KT2C3Cb, KN2Cb, KP1H2Cb, KT1H2Cb, KN2Cc, KP1H2Cc, KT1H2Cc, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set KN1C = ?, KN1H = ?, KP1C2C1H = ?, KT1C2C = ?, KT1C1H = ?, KNNic1Negativo = ?, KNnic23 = ?, KNadenoCancer = ?, KN2C = ?, "
                    + "KNbaixoRisco = ?, KNhsil = ?, KNaltoRisco = ?, KN3Ca = ?, KP2C3Ca= ?, KT2C3Ca = ?, KN3Cb = ?, KP2C3Cb = ?, KT2C3Cb = ?,  KN2Cb = ?, KP1H2Cb = ?, KT1H2Cb = ?, "
                    + "KN2Cc = ?, KP1H2Cc = ?, KT1H2Cc = ?"
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";

            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                boolean temOutroExame = false;
                boolean ano2014 = false;
                boolean exameHisto = false;
                int cancer = 0;
                int nic1Negativo = 0;
                int nic23 = 0;
                int kn1h = 0;
                int kn1c = 1;
                int kp1c2c1h = 0;
                int kn3cb = 0;
                int kn3ca = 0;
                int kn2c = 0;
                int kn2cb = 0;
                int kn2cc = 0;
                int kp2c3cb = 0;
                int kp2c3ca = 0;
                int knBaixoRisco = 0;
                int kp1h2cb = 0;
                int kp1h2cc = 0;
                int knAltoRisco = 0;
                int knhsil = 0;
                int intervaloCito1Cito2 = -1;
                int intervaloCito2Cito3a = -1;
                int intervaloCito2Cito3b = -1;
                int intervaloHistoCito2b = -1;
                int intervaloHistoCito2c = -1;
                int intervaloCito1Histo1 = -1;
                boolean segundoCito = false;
                Date dataLiberacaoCito2 = null;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito, lcdataLiberacaoCito2 = null;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int idade = rsCitoRecords.getInt("C_ID_IDAD");
                int hsil = rsCitoRecords.getInt("hsil");
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2014) && (hsil == 1) && (idade < 25))) {
                    continue;
                }
                kn1c = 1;
                if (lcdataLiberacaoCito.getYear() == 2014) {
                    ano2014 = true;
                }
                // verifica se a mulher realizou exame histologico
                psReadHistoRecords.setInt(1, uid);
                ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                while (rsHistoRecords.next()) {
                    Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                    Date dataLiberacaoHisto = rsHistoRecords.getDate("data_liberacao");
                    // compara datas
                    LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                    LocalDate lcdataLiberacaoHisto = IndicadoresLongitudinais.toLocalDate(dataLiberacaoHisto);
                    int intervalo = (int) DAYS.between(lcdataLiberacaoCito, lcdataExameHisto);
                    if (dataExameHisto.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloCito1Histo1 = intervalo;
                        cancer = rsHistoRecords.getInt("aden_cancer_histo");
                        nic1Negativo = rsHistoRecords.getInt("negativa_nic1");
                        nic23 = rsHistoRecords.getInt("nic_23");
                        if (nic23 == 1) {
                            kp1h2cc = 1;
                            while (rsCitoRecords.next()) {
                                Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                                lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                                if (dataColetaCito2.compareTo(dataLiberacaoHisto) >= 0) {
                                    intervaloHistoCito2c = (int) DAYS.between(lcdataLiberacaoHisto, lcdataColetaCito2);
                                    kp1h2cc = 0;
                                    kn2cc = 1;
                                    break;
                                }
                            }
                        }
                        if (nic1Negativo == 1) {
                            kp1h2cb = 1;
                            while (rsCitoRecords.next()) {
                                Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                                lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                                if (dataColetaCito2.compareTo(dataLiberacaoHisto) >= 0) {
                                    intervaloHistoCito2b = (int) DAYS.between(lcdataLiberacaoHisto, lcdataColetaCito2);
                                    kp1h2cb = 0;
                                    kn2cb = 1;
                                    break;
                                }
                            }
                        }
                        kn1h = 1;
                        exameHisto = true;
                        temOutroExame = true;
                        rsHistoRecords.close();
                        break;
                    }
                }
                // segundo cito
                if (!exameHisto) {
                    if (rsCitoRecords.next()) {
                        Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                        dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                        lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                        lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                        if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                            intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                            segundoCito = true;
                            temOutroExame = true;
                        }
                    }
                    if (segundoCito) {
                        kn2c = 1;
                        hsil = rsCitoRecords.getInt("hsil");
                        knAltoRisco = rsCitoRecords.getInt("i_k_alto_risco");
                        knBaixoRisco = rsCitoRecords.getInt("i_k_baixo_risco");
                        if (knBaixoRisco == 1) {
                            kp2c3cb = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3b = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    kn3cb = 1;
                                    kp2c3cb = 0;
                                }
                            }
                        }
                        if (hsil == 1) {
                            knhsil = 1;
                            kp2c3ca = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3a = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    kn3ca = 1;
                                    kp2c3ca = 0;
                                }
                            }
                        }
                    }
                }
                if (ano2014 && !temOutroExame) {
                    continue;
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                if ((kn2c == 1) || (kn1h == 1)) {
                    kp1c2c1h = 0;
                } else {
                    kp1c2c1h = 1;
                }
                if (rs.next()) {
                    kn1c = rs.getInt("KN1C") + 1;
                    int intervaloAntigo = rs.getInt("KT1C1H");
                    if (intervaloCito1Histo1 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Histo1 = intervaloCito1Histo1 + intervaloAntigo;
                        }
                    } else {
                        intervaloCito1Histo1 = intervaloAntigo;
                    }
                    kn1h = rs.getInt("KN1H") + kn1h;
                    intervaloAntigo = rs.getInt("KT1H2Cb");
                    if (intervaloHistoCito2b != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHistoCito2b = intervaloAntigo + intervaloHistoCito2b;
                        }
                    } else {
                        intervaloHistoCito2b = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("KT1H2Cc");
                    if (intervaloHistoCito2c != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHistoCito2c = intervaloAntigo + intervaloHistoCito2c;
                        }
                    } else {
                        intervaloHistoCito2c = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("KT2C3Cb");
                    if (intervaloCito2Cito3b != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3b = intervaloAntigo + intervaloCito2Cito3b;
                        }
                    } else {
                        intervaloCito2Cito3b = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("KT2C3Ca");
                    if (intervaloCito2Cito3a != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3a = intervaloAntigo + intervaloCito2Cito3a;
                        }
                    } else {
                        intervaloCito2Cito3a = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("KT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    kp1c2c1h = kp1c2c1h + rs.getInt("KP1C2C1H");
                    cancer = rs.getInt("KNadenoCancer") + cancer;
                    nic1Negativo = rs.getInt("KNNic1Negativo") + nic1Negativo;
                    nic23 = rs.getInt("KNNic23") + nic23;
                    kn2c = kn2c + rs.getInt("KN2C");
                    knBaixoRisco = rs.getInt("KNBaixoRisco") + knBaixoRisco;
                    knhsil = rs.getInt("KNhsil") + knhsil;
                    knAltoRisco = rs.getInt("KNaltoRisco") + knAltoRisco;
                    kn3ca = rs.getInt("KN3Ca") + kn3ca;
                    kn3cb = rs.getInt("KN3Cb") + kn3cb;
                    kp2c3ca = rs.getInt("KP2C3Ca") + kp2c3ca;
                    kp2c3cb = rs.getInt("KP2C3Cb") + kp2c3cb;
                    kn2cb = rs.getInt("KN2Cb") + kn2cb;
                    kn2cc = rs.getInt("KN2Cc") + kn2cc;
                    kp1h2cb = rs.getInt("KP1H2Cb") + kp1h2cb;
                    kp1h2cc = rs.getInt("KP1H2Cc") + kp1h2cc;
                    psUpdateFact.setInt(1, kn1c);
                    psUpdateFact.setInt(2, kn1h);
                    psUpdateFact.setInt(3, kp1c2c1h);
                    psUpdateFact.setInt(4, intervaloCito1Cito2);
                    psUpdateFact.setInt(5, intervaloCito1Histo1);
                    psUpdateFact.setInt(6, nic1Negativo);
                    psUpdateFact.setInt(7, nic23);
                    psUpdateFact.setInt(8, cancer);
                    psUpdateFact.setInt(9, kn2c);
                    psUpdateFact.setInt(10, knBaixoRisco);
                    psUpdateFact.setInt(11, knhsil);
                    psUpdateFact.setInt(12, knAltoRisco);
                    psUpdateFact.setInt(13, kn3ca);
                    psUpdateFact.setInt(14, kp2c3ca);
                    psUpdateFact.setInt(15, intervaloCito2Cito3a);
                    psUpdateFact.setInt(16, kn3cb);
                    psUpdateFact.setInt(17, kp2c3cb);
                    psUpdateFact.setInt(18, intervaloCito2Cito3b);
                    psUpdateFact.setInt(19, kn2cb);
                    psUpdateFact.setInt(20, kp1h2cb);
                    psUpdateFact.setInt(21, intervaloHistoCito2b);
                    psUpdateFact.setInt(22, kn2cc);
                    psUpdateFact.setInt(23, kp1h2cc);
                    psUpdateFact.setInt(24, intervaloHistoCito2c);
                    psUpdateFact.setInt(25, idTempo);
                    psUpdateFact.setInt(26, idFaixa);
                    psUpdateFact.setInt(27, idColeta);
                    psUpdateFact.setInt(28, idMunicipio);
                    psUpdateFact.setInt(29, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, kn1c);
                    psInsertFact.setInt(2, kn1h);
                    psInsertFact.setInt(3, kp1c2c1h);
                    psInsertFact.setInt(4, intervaloCito1Cito2);
                    psInsertFact.setInt(5, intervaloCito1Histo1);
                    psInsertFact.setInt(6, nic1Negativo);
                    psInsertFact.setInt(7, nic23);
                    psInsertFact.setInt(8, cancer);
                    psInsertFact.setInt(9, kn2c);
                    psInsertFact.setInt(10, knBaixoRisco);
                    psInsertFact.setInt(11, knhsil);
                    psInsertFact.setInt(12, knAltoRisco);
                    psInsertFact.setInt(13, kn3ca);
                    psInsertFact.setInt(14, kp2c3ca);
                    psInsertFact.setInt(15, intervaloCito2Cito3a);
                    psInsertFact.setInt(16, kn3cb);
                    psInsertFact.setInt(17, kp2c3cb);
                    psInsertFact.setInt(18, intervaloCito2Cito3b);
                    psInsertFact.setInt(19, kn2cb);
                    psInsertFact.setInt(20, kp1h2cb);
                    psInsertFact.setInt(21, intervaloHistoCito2b);
                    psInsertFact.setInt(22, kn2cc);
                    psInsertFact.setInt(23, kp1h2cc);
                    psInsertFact.setInt(24, intervaloHistoCito2c);
                    psInsertFact.setInt(25, idTempo);
                    psInsertFact.setInt(26, idFaixa);
                    psInsertFact.setInt(27, idColeta);
                    psInsertFact.setInt(28, idMunicipio);
                    psInsertFact.setInt(29, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorA() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where (asc_us=1 OR lsil=1) and C_ID_IDAD < 25 and Year(data_liberacao) = 2012  ", uids);
            String readCitoRecords = "select data_coleta, data_liberacao, C_ID_IDAD, lsil, asc_us, sem_atipia, atipia_h, adeno_cancers, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);
            String fetchFact = "select AN1C, AP1C2C, AT1C2C, AN2C, ANSEMATIPIA, ANASCLSIL, ANATIPIAH, ANCANCERS"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (AN1C, AP1C2C, AT1C2C, AN2C, ANSEMATIPIA, ANASCLSIL, ANATIPIAH, ANCANCERS, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set AN1C = ?, AP1C2C = ?, AT1C2C = ?, AN2C = ?, "
                    + "ANSEMATIPIA = ?, ANASCLSIL = ?, ANATIPIAH = ?, ANCANCERS = ? "
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? AND municipio_residencia = ? AND C_CNES = ?";

            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                int anatipiah = 0;
                int an1c = 0;
                int ap1c2c = 0;
                int an2c = 0;
                int ansematipia = 0;
                int anasclsil = 0;
                int ancancers = 0;
                int intervaloCito1Cito2 = -1;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                int ascus = rsCitoRecords.getInt("asc_us");
                int lsil = rsCitoRecords.getInt("lsil");
                int idade = rsCitoRecords.getInt("C_ID_IDAD");

                /*               if ((idTempo == 441) && (idFaixa == 2) && (idColeta == 541) && (idMunicipio == 330455) && (idLaboratorio == 2273284)) {
                    System.out.println("parei");
                }
                 */ Date dataLiberacaoCito;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                LocalDate lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() == 2012) && idade < 25 && (ascus == 1 || lsil == 1))) {
                    continue;
                }
                an1c = 1;
                ap1c2c = 1;
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (rsCitoRecords.next()) {
                    Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                    lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                    if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                        an2c = 1;
                        ap1c2c = 0;
                        ascus = rsCitoRecords.getInt("asc_us");
                        ancancers = rsCitoRecords.getInt("adeno_cancers");
                        lsil = rsCitoRecords.getInt("lsil");
                        ansematipia = rsCitoRecords.getInt("sem_atipia");
                        anatipiah = rsCitoRecords.getInt("atipia_h");
                        if ((lsil == 1) || (ascus == 1)) {
                            anasclsil = 1;
                        }
                    }
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                if (rs.next()) {
                    an1c = rs.getInt("AN1C") + 1;
                    ap1c2c = rs.getInt("AP1C2C") + ap1c2c;
                    int intervaloAntigo = rs.getInt("AT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    ancancers = rs.getInt("ANCANCERS") + ancancers;
                    anatipiah = rs.getInt("ANATIPIAH") + anatipiah;
                    an2c = rs.getInt("AN2C") + an2c;
                    ansematipia = rs.getInt("ANSEMATIPIA") + ansematipia;
                    anasclsil = rs.getInt("ANASCLSIL") + anasclsil;
                    psUpdateFact.setInt(1, an1c);
                    psUpdateFact.setInt(2, ap1c2c);
                    psUpdateFact.setInt(3, intervaloCito1Cito2);
                    psUpdateFact.setInt(4, an2c);
                    psUpdateFact.setInt(5, ansematipia);
                    psUpdateFact.setInt(6, anasclsil);
                    psUpdateFact.setInt(7, anatipiah);
                    psUpdateFact.setInt(8, ancancers);
                    psUpdateFact.setInt(9, idTempo);
                    psUpdateFact.setInt(10, idFaixa);
                    psUpdateFact.setInt(11, idColeta);
                    psUpdateFact.setInt(12, idMunicipio);
                    psUpdateFact.setInt(13, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, an1c);
                    psInsertFact.setInt(2, ap1c2c);
                    psInsertFact.setInt(3, intervaloCito1Cito2);
                    psInsertFact.setInt(4, an2c);
                    psInsertFact.setInt(5, ansematipia);
                    psInsertFact.setInt(6, anasclsil);
                    psInsertFact.setInt(7, anatipiah);
                    psInsertFact.setInt(8, ancancers);
                    psInsertFact.setInt(9, idTempo);
                    psInsertFact.setInt(10, idFaixa);
                    psInsertFact.setInt(11, idColeta);
                    psInsertFact.setInt(12, idMunicipio);
                    psInsertFact.setInt(13, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
                count++;
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorB() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where sem_atipia = 1 and (Year(data_liberacao) = 2012 or Year(data_liberacao) = 2013)", uids);
            String readCitoRecords = "select data_coleta, data_liberacao, sem_atipia, C_ID_IDAD, asc_us, lsil, cancer_atipia_h, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);

            String readHistoRecords = "select data_coleta, data_liberacao"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select BN1C,  BP1C2C, BT1C2C, BN2C, BNSEMATIPIA, BNASCLSIL, BNASCUS2, "
                    + "BNASCUS3, BNNIC1_1, BCANCERSATIPIAH, BN3CA, BP2C3CA, BT2C3CA, BN3CB, BP2C3CB, BT2C3CB, BN3CC, BP2C3CC, BT2C3CC, BN1H, BP2C1H, BT2C1H"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (BN1C,  BP1C2C, BT1C2C, BN2C, BNSEMATIPIA, BNASCLSIL, BNASCUS2, "
                    + "BNASCUS3, BNNIC1_1, BCANCERSATIPIAH, BN3CA, BP2C3CA, BT2C3CA, BN3CB, BP2C3CB, BT2C3CB, BN3CC, BP2C3CC, BT2C3CC, BN1H, BP2C1H, BT2C1H, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set BN1C = ?, BP1C2C = ?, BT1C2C = ?, BN2C = ?, BNSEMATIPIA = ?, BNASCLSIL = ?, BNASCUS2 = ?, BNASCUS3 = ?, BNNIC1_1 = ?, "
                    + "BCANCERSATIPIAH = ?, BN3CA = ?, BP2C3CA= ?, BT2C3CA = ?, BN3CB = ?, BP2C3CB = ?, BT2C3CB = ?, BN3CC = ?, BP2C3CC = ?, BT2C3CC = ?, BN1H = ?, BP2C1H = ?, "
                    + "BT2C1H = ?"
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";

            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                int cancerAtipia = 0;
                int bnic_1 = 0;
                int bn1h = 0;
                int bn1c = 1;
                int bp1c2c = 0;
                int bn3cb = 0;
                int bn3ca = 0;
                int bn3cc = 0;
                int bn2c = 0;
                int bp2c3cb = 0;
                int bp2c3ca = 0;
                int bp2c3cc = 0;
                int bp2c1h = 0;
                int bnsematipia = 0;
                int bnasclsil = 0;
                int bascus2 = 0;
                int bascus3 = 0;
                int intervaloCito1Cito2 = -1;
                int intervaloCito2Cito3a = -1;
                int intervaloCito2Cito3b = -1;
                int intervaloCito2Cito3c = -1;
                int intervaloCito2Histo1 = -1;
                Date dataLiberacaoCito2 = null;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito2 = null;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int idade = rsCitoRecords.getInt("C_ID_IDAD");
                int sematipia = rsCitoRecords.getInt("sem_atipia");
                LocalDate lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2013) && (sematipia == 1))) {
                    continue;
                }
                bp1c2c = 1;
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (rsCitoRecords.next()) {
                    Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                    dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                    lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                    lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                    if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                        bn2c = 1;
                        bp1c2c = 0;
                        bnsematipia = rsCitoRecords.getInt("sem_atipia");
                        int ascus = rsCitoRecords.getInt("asc_us");
                        idade = rsCitoRecords.getInt("C_ID_IDAD");
                        int lsil = rsCitoRecords.getInt("lsil");
                        cancerAtipia = rsCitoRecords.getInt("cancer_atipia_h");
                        if (cancerAtipia == 1) {
                            psReadHistoRecords.setInt(1, uid);
                            ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                            bp2c1h = 1;
                            while (rsHistoRecords.next()) {
                                Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                                LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                                if (dataExameHisto.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Histo1 = (int) DAYS.between(lcdataLiberacaoCito2, lcdataExameHisto);
                                    bn1h = 1;
                                    bp2c1h = 0;
                                }
                                break;
                            }
                        }
                        if (((ascus == 1) || (lsil == 1)) && (idade < 25)) {
                            bnasclsil = 1;
                        }
                        if ((ascus == 1) && (idade >= 30)) {
                            bascus2 = 1;
                            bp2c3ca = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3a = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    bn3ca = 1;
                                    bp2c3ca = 0;
                                }
                            }
                        }
                        if ((ascus == 1) && (idade >= 25) && (idade < 30)) {
                            bascus3 = 1;
                            bp2c3cb = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3b = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    bn3cb = 1;
                                    bp2c3cb = 0;
                                }
                            }
                        }
                        if ((lsil == 1) && (idade >= 25)) {
                            bnic_1 = 1;
                            bp2c3cc = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3c = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    bn3cc = 1;
                                    bp2c3cc = 0;
                                }
                            }
                        }
                    }
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                if (rs.next()) {
                    bn1c = rs.getInt("BN1C") + 1;
                    bn2c = rs.getInt("BN2C") + bn2c;
                    bp1c2c = rs.getInt("BP1C2C") + bp1c2c;
                    int intervaloAntigo = rs.getInt("BT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("BT2C3CB");
                    if (intervaloCito2Cito3b != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3b = intervaloAntigo + intervaloCito2Cito3b;
                        }
                    } else {
                        intervaloCito2Cito3b = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("BT2C3CA");
                    if (intervaloCito2Cito3a != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3a = intervaloAntigo + intervaloCito2Cito3a;
                        }
                    } else {
                        intervaloCito2Cito3a = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("BT2C3CC");
                    if (intervaloCito2Cito3c != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3c = intervaloAntigo + intervaloCito2Cito3c;
                        }
                    } else {
                        intervaloCito2Cito3c = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("BT2C1H");
                    if (intervaloCito2Histo1 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Histo1 = intervaloAntigo + intervaloCito2Histo1;
                        }
                    } else {
                        intervaloCito2Histo1 = intervaloAntigo;
                    }
                    cancerAtipia = rs.getInt("BCANCERSATIPIAH") + cancerAtipia;
                    bnic_1 = rs.getInt("BNNIC1_1") + bnic_1;
                    bnasclsil = rs.getInt("BNASCLSIL") + bnasclsil;
                    bascus2 = bascus2 + rs.getInt("BNASCUS2");
                    bascus3 = rs.getInt("BNASCUS3") + bascus3;
                    bnsematipia = rs.getInt("BNSEMATIPIA") + bnsematipia;
                    bn3ca = rs.getInt("BN3CA") + bn3ca;
                    bn3cb = rs.getInt("BN3CB") + bn3cb;
                    bn3cc = rs.getInt("BN3CC") + bn3cc;
                    bp2c3ca = rs.getInt("BP2C3CA") + bp2c3ca;
                    bp2c3cb = rs.getInt("BP2C3CB") + bp2c3cb;
                    bp2c3cc = rs.getInt("BP2C3CC") + bp2c3cc;
                    bn1h = rs.getInt("BN1H") + bn1h;
                    bp2c1h = rs.getInt("BP2C1H") + bp2c1h;
                    psUpdateFact.setInt(1, bn1c);
                    psUpdateFact.setInt(2, bp1c2c);
                    psUpdateFact.setInt(3, intervaloCito1Cito2);
                    psUpdateFact.setInt(4, bn2c);
                    psUpdateFact.setInt(5, bnsematipia);
                    psUpdateFact.setInt(6, bnasclsil);
                    psUpdateFact.setInt(7, bascus2);
                    psUpdateFact.setInt(8, bascus3);
                    psUpdateFact.setInt(9, bnic_1);
                    psUpdateFact.setInt(10, cancerAtipia);
                    psUpdateFact.setInt(11, bn3ca);
                    psUpdateFact.setInt(12, bp2c3ca);
                    psUpdateFact.setInt(13, intervaloCito2Cito3a);
                    psUpdateFact.setInt(14, bn3cb);
                    psUpdateFact.setInt(15, bp2c3cb);
                    psUpdateFact.setInt(16, intervaloCito2Cito3b);
                    psUpdateFact.setInt(17, bn3cc);
                    psUpdateFact.setInt(18, bp2c3cc);
                    psUpdateFact.setInt(19, intervaloCito2Cito3c);
                    psUpdateFact.setInt(20, bn1h);
                    psUpdateFact.setInt(21, bp2c1h);
                    psUpdateFact.setInt(22, intervaloCito2Histo1);
                    psUpdateFact.setInt(23, idTempo);
                    psUpdateFact.setInt(24, idFaixa);
                    psUpdateFact.setInt(25, idColeta);
                    psUpdateFact.setInt(26, idMunicipio);
                    psUpdateFact.setInt(27, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, bn1c);
                    psInsertFact.setInt(2, bp1c2c);
                    psInsertFact.setInt(3, intervaloCito1Cito2);
                    psInsertFact.setInt(4, bn2c);
                    psInsertFact.setInt(5, bnsematipia);
                    psInsertFact.setInt(6, bnasclsil);
                    psInsertFact.setInt(7, bascus2);
                    psInsertFact.setInt(8, bascus3);
                    psInsertFact.setInt(9, bnic_1);
                    psInsertFact.setInt(10, cancerAtipia);
                    psInsertFact.setInt(11, bn3ca);
                    psInsertFact.setInt(12, bp2c3ca);
                    psInsertFact.setInt(13, intervaloCito2Cito3a);
                    psInsertFact.setInt(14, bn3cb);
                    psInsertFact.setInt(15, bp2c3cb);
                    psInsertFact.setInt(16, intervaloCito2Cito3b);
                    psInsertFact.setInt(17, bn3cc);
                    psInsertFact.setInt(18, bp2c3cc);
                    psInsertFact.setInt(19, intervaloCito2Cito3c);
                    psInsertFact.setInt(20, bn1h);
                    psInsertFact.setInt(21, bp2c1h);
                    psInsertFact.setInt(22, intervaloCito2Histo1);
                    psInsertFact.setInt(23, idTempo);
                    psInsertFact.setInt(24, idFaixa);
                    psInsertFact.setInt(25, idColeta);
                    psInsertFact.setInt(26, idMunicipio);
                    psInsertFact.setInt(27, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorC() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where asc_us = 1 and C_ID_IDAD >= 25 and C_ID_IDAD < 30  and (Year(data_liberacao) = 2012 or Year(data_liberacao) = 2013)", uids);
            String readCitoRecords = "select data_coleta, data_liberacao, C_ID_IDAD, asc_us, com_atipia, sem_atipia, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);
            String readHistoRecords = "select data_coleta, data_liberacao, c_d_alto_risco, negativa_nic1"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select CN1C,  CP1C2C, CT1C2C, CN2C, CN2CP, CP2CP1HA3CB, CT2CP1HA, CT2CP3CB, CN1HA, "
                    + "CN3CB, CN1HAALTORISCO, CN1HABAIXORISCO, CP1HA3CC, CT1HA3CC, CN3CC, CN2CN, CP2CN3CA, CT2CN3CA, CN3CA, CN3CP, CP3CP1HB4C, CT3CP1HB, CT3CP4C, CN3CN, CN1HB, "
                    + " CN4C, CN1HBALTORISCO, CN1HBBAIXORISCO"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (CN1C,  CP1C2C, CT1C2C, CN2C, CN2CP, CP2CP1HA3CB, CT2CP1HA, CT2CP3CB, "
                    + "CN1HA, CN3CB, CN1HAALTORISCO, CN1HABAIXORISCO, CP1HA3CC, CT1HA3CC, CN3CC, CN2CN, CP2CN3CA, CT2CN3CA, CN3CA, CN3CP, CP3CP1HB4C, CT3CP1HB, CT3CP4C, CN3CN, CN1HB, "
                    + " CN4C, CN1HBALTORISCO, CN1HBBAIXORISCO, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set CN1C = ?, CP1C2C = ?, CT1C2C = ?, CN2C = ?, CN2CP = ?, CP2CP1HA3CB = ?, CT2CP1HA = ?, CT2CP3CB = ?, CN1HA = ?, CN3CB = ?, "
                    + "CN1HAALTORISCO = ?, CN1HABAIXORISCO = ?, CP1HA3CC = ?, CT1HA3CC = ?, CN3CC = ?, CN2CN = ?, CP2CN3CA = ?, CT2CN3CA = ?, CN3CA = ?, CN3CP = ?, CP3CP1HB4C = ?, CT3CP1HB = ?, CT3CP4C = ?, CN3CN = ?, CN1HB = ?, "
                    + " CN4C = ?, CN1HBALTORISCO = ?, CN1HBBAIXORISCO = ?"
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";

            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                if (uid == 27502) {
                    System.out.println("uid = " + uid);
                }

                boolean exameHisto1 = false;
                int cn1c = 1;
                int cp1c2c = 0;
                int cn2c = 0;
                int cn2cp = 0;
                int cn3ca = 0;
                int cn3cc = 0;
                int cn3cb = 0;
                int cn1ha = 0;
                int cn1hb = 0;
                int cn3cn = 0;
                int cn3cp = 0;
                int cn4c = 0;
                int cn1haaltorisco = 0;
                int cn1habaixorisco = 0;
                int cn1hbbaixorisco = 0;
                int cn1hbaltorisco = 0;
                int cp1h3c = 0;
                int cp2cp1ha3cb = 0;
                int cn2cn = 0;
                int cp2c3c = 0;
                int cp3c1h = 0;
                int intervaloCito1Cito2 = -1;
                int intervaloCito2Cito3a = -1;
                int intervaloCito2Cito3b = -1;
                int intervaloCito3Cito4 = -1;
                int intervaloCito3Histo1 = -1;
                int intervaloCito2Histo1 = -1;
                int intervaloHisto1Cito3 = -1;
                Date dataLiberacaoCito2 = null;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito2 = null;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int idade = rsCitoRecords.getInt("C_ID_IDAD");
                int ascus = rsCitoRecords.getInt("asc_us");
                LocalDate lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2013) && (ascus == 1) && (idade >= 25) && (idade < 30))) {
                    continue;
                }
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                cp1c2c = 1;
                if (rsCitoRecords.next()) {
                    Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                    dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                    lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                    lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                    if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                        cn2c = 1;
                        cp1c2c = 0;
                        int comAtipia = rsCitoRecords.getInt("com_atipia");
                        int semAtipia = rsCitoRecords.getInt("sem_atipia");
                        if (comAtipia == 1) {
                            cn2cp = 1;
                            psReadHistoRecords.setInt(1, uid);
                            ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                            cp2cp1ha3cb = 1;
                            while (rsHistoRecords.next()) {
                                Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                                LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                                if (dataExameHisto.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Histo1 = (int) DAYS.between(lcdataLiberacaoCito2, lcdataExameHisto);
                                    cn1ha = 1;
                                    cp2cp1ha3cb = 0;
                                    exameHisto1 = true;
                                    int altoRisco = rsHistoRecords.getInt("c_d_alto_risco");
                                    int baixoRisco = rsHistoRecords.getInt("negativa_nic1");
                                    if (baixoRisco == 1) {
                                        cn1habaixorisco = 1;
                                        cp1h3c = 1;
                                        while (rsCitoRecords.next()) {
                                            Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                            LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                            Date dataLiberacaoHisto1 = rsHistoRecords.getDate("data_liberacao");
                                            LocalDate lcdataLiberacaoHisto1 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoHisto1);
                                            if (dataColetaCito3.compareTo(dataLiberacaoHisto1) >= 0) {
                                                intervaloHisto1Cito3 = (int) DAYS.between(lcdataLiberacaoHisto1, lcdataColetaCito3);
                                                cn3cc = 1;
                                                cp1h3c = 0;
                                                break;
                                            }
                                        }
                                    } else if (altoRisco == 1) {
                                        cn1haaltorisco = 1;
                                    }
                                    break;
                                }
                            }
                            if (!exameHisto1) {
                                if (rsCitoRecords.next()) {
                                    Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                    LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                    if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                        intervaloCito2Cito3b = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                        cn3cb = 1;
                                        cp2cp1ha3cb = 0;
                                    }
                                }
                            }
                        } else if (semAtipia == 1) {
                            cn2cn = 1;
                            cp2c3c = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                Date dataLiberacaoCito3 = rsCitoRecords.getDate("data_liberacao");
                                LocalDate lcdataLiberacaoCito3 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3a = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    cn3ca = 1;
                                    cp2c3c = 0;
                                    comAtipia = rsCitoRecords.getInt("com_atipia");
                                    semAtipia = rsCitoRecords.getInt("sem_atipia");
                                    if (comAtipia == 1) {
                                        cn3cp = 1;
                                        psReadHistoRecords.setInt(1, uid);
                                        ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                                        cp3c1h = 1;
                                        while (rsHistoRecords.next()) {
                                            Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                                            LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                                            if (dataExameHisto.compareTo(dataLiberacaoCito3) >= 0) {
                                                intervaloCito3Histo1 = (int) DAYS.between(lcdataLiberacaoCito3, lcdataExameHisto);
                                                cn1hb = 1;
                                                cp3c1h = 0;
                                                exameHisto1 = true;
                                                int altoRisco = rsHistoRecords.getInt("c_d_alto_risco");
                                                int baixoRisco = rsHistoRecords.getInt("negativa_nic1");
                                                if (baixoRisco == 1) {
                                                    cn1hbbaixorisco = 1;
                                                } else if (altoRisco == 1) {
                                                    cn1hbaltorisco = 1;
                                                }
                                                break;
                                            }
                                        }
                                        if (!exameHisto1) {
                                            if (rsCitoRecords.next()) {
                                                Date dataColetaCito4 = rsCitoRecords.getDate("data_coleta");
                                                LocalDate lcdataColetaCito4 = IndicadoresLongitudinais.toLocalDate(dataColetaCito4);
                                                if (dataColetaCito4.compareTo(dataLiberacaoCito3) >= 0) {
                                                    intervaloCito3Cito4 = (int) DAYS.between(lcdataLiberacaoCito3, lcdataColetaCito4);
                                                    cn4c = 1;
                                                    cp3c1h = 0;
                                                }
                                            }
                                        }
                                    } else if (semAtipia == 1) {
                                        cn3cn = 1;
                                    }
                                }
                            }

                        }
                    }
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                if (rs.next()) {
                    cn1c = rs.getInt("CN1C") + 1;
                    cp1c2c = rs.getInt("CP1C2C") + cp1c2c;
                    cn2c = rs.getInt("CN2C") + cn2c;
                    cn2cp = rs.getInt("CN2CP") + cn2cp;
                    cp2cp1ha3cb = rs.getInt("CP2CP1HA3CB") + cp2cp1ha3cb;
                    cn1ha = rs.getInt("CN1HA") + cn1ha;
                    cn3cb = rs.getInt("CN3CB") + cn3cb;
                    cn1haaltorisco = rs.getInt("CN1HAALTORISCO") + cn1haaltorisco;
                    cn1habaixorisco = rs.getInt("CN1HABAIXORISCO") + cn1habaixorisco;
                    cp1h3c = rs.getInt("CP1HA3CC") + cp1h3c;
                    cn3cc = rs.getInt("CN3CC") + cn3cc;
                    cn2cn = rs.getInt("CN2CN") + cn2cn;
                    cp2c3c = rs.getInt("CP2CN3CA") + cp2c3c;
                    cn3ca = rs.getInt("CN3CA") + cn3ca;
                    cn3cp = rs.getInt("CN3CP") + cn3cp;
                    cp3c1h = rs.getInt("CP3CP1HB4C") + cp3c1h;
                    cn3cn = rs.getInt("CN3CN") + cn3cn;
                    cn1hb = rs.getInt("CN1HB") + cn1hb;
                    cn1hbaltorisco = rs.getInt("CN1HBALTORISCO") + cn1hbaltorisco;
                    cn1hbbaixorisco = rs.getInt("CN1HBBAIXORISCO") + cn1hbbaixorisco;
                    cn4c = rs.getInt("CN4C") + cn4c;
                    int intervaloAntigo = rs.getInt("CT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("CT1HA3CC");
                    if (intervaloHisto1Cito3 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHisto1Cito3 = intervaloHisto1Cito3 + intervaloAntigo;
                        }
                    } else {
                        intervaloHisto1Cito3 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("CT2CP3CB");
                    if (intervaloCito2Cito3b != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3b = intervaloAntigo + intervaloCito2Cito3b;
                        }
                    } else {
                        intervaloCito2Cito3b = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("CT2CN3CA");
                    if (intervaloCito2Cito3a != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3a = intervaloAntigo + intervaloCito2Cito3a;
                        }
                    } else {
                        intervaloCito2Cito3a = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("CT3CP4C");
                    if (intervaloCito3Cito4 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito3Cito4 = intervaloAntigo + intervaloCito3Cito4;
                        }
                    } else {
                        intervaloCito3Cito4 = rs.getInt("CT3CP4C");
                    }
                    intervaloAntigo = rs.getInt("CT2CP1HA");
                    if (intervaloCito2Histo1 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Histo1 = intervaloAntigo + intervaloCito2Histo1;
                        }
                    } else {
                        intervaloCito2Histo1 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("CT3CP1HB");
                    if (intervaloCito3Histo1 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito3Histo1 = intervaloAntigo + intervaloCito3Histo1;
                        }
                    } else {
                        intervaloCito3Histo1 = intervaloAntigo;
                    }
                    psUpdateFact.setInt(1, cn1c);
                    psUpdateFact.setInt(2, cp1c2c);
                    psUpdateFact.setInt(3, intervaloCito1Cito2);
                    psUpdateFact.setInt(4, cn2c);
                    psUpdateFact.setInt(5, cn2cp);
                    psUpdateFact.setInt(6, cp2cp1ha3cb);
                    psUpdateFact.setInt(7, intervaloCito2Histo1);
                    psUpdateFact.setInt(8, intervaloCito2Cito3b);
                    psUpdateFact.setInt(9, cn1ha);
                    psUpdateFact.setInt(10, cn3cb);
                    psUpdateFact.setInt(11, cn1haaltorisco);
                    psUpdateFact.setInt(12, cn1habaixorisco);
                    psUpdateFact.setInt(13, cp1h3c);
                    psUpdateFact.setInt(14, intervaloHisto1Cito3);
                    psUpdateFact.setInt(15, cn3cc);
                    psUpdateFact.setInt(16, cn2cn);
                    psUpdateFact.setInt(17, cp2c3c);
                    psUpdateFact.setInt(18, intervaloCito2Cito3a);
                    psUpdateFact.setInt(19, cn3ca);
                    psUpdateFact.setInt(20, cn3cp);
                    psUpdateFact.setInt(21, cp3c1h);
                    psUpdateFact.setInt(22, intervaloCito3Histo1);
                    psUpdateFact.setInt(23, intervaloCito3Cito4);
                    psUpdateFact.setInt(24, cn3cn);
                    psUpdateFact.setInt(25, cn1hb);
                    psUpdateFact.setInt(26, cn4c);
                    psUpdateFact.setInt(27, cn1hbaltorisco);
                    psUpdateFact.setInt(28, cn1hbbaixorisco);
                    psUpdateFact.setInt(29, idTempo);
                    psUpdateFact.setInt(30, idFaixa);
                    psUpdateFact.setInt(31, idColeta);
                    psUpdateFact.setInt(32, idMunicipio);
                    psUpdateFact.setInt(33, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, cn1c);
                    psInsertFact.setInt(2, cp1c2c);
                    psInsertFact.setInt(3, intervaloCito1Cito2);
                    psInsertFact.setInt(4, cn2c);
                    psInsertFact.setInt(5, cn2cp);
                    psInsertFact.setInt(6, cp2cp1ha3cb);
                    psInsertFact.setInt(7, intervaloCito2Histo1);
                    psInsertFact.setInt(8, intervaloCito2Cito3b);
                    psInsertFact.setInt(9, cn1ha);
                    psInsertFact.setInt(10, cn3cb);
                    psInsertFact.setInt(11, cn1haaltorisco);
                    psInsertFact.setInt(12, cn1habaixorisco);
                    psInsertFact.setInt(13, cp1h3c);
                    psInsertFact.setInt(14, intervaloHisto1Cito3);
                    psInsertFact.setInt(15, cn3cc);
                    psInsertFact.setInt(16, cn2cn);
                    psInsertFact.setInt(17, cp2c3c);
                    psInsertFact.setInt(18, intervaloCito2Cito3a);
                    psInsertFact.setInt(19, cn3ca);
                    psInsertFact.setInt(20, cn3cp);
                    psInsertFact.setInt(21, cp3c1h);
                    psInsertFact.setInt(22, intervaloCito3Histo1);
                    psInsertFact.setInt(23, intervaloCito3Cito4);
                    psInsertFact.setInt(24, cn3cn);
                    psInsertFact.setInt(25, cn1hb);
                    psInsertFact.setInt(26, cn4c);
                    psInsertFact.setInt(27, cn1hbaltorisco);
                    psInsertFact.setInt(28, cn1hbbaixorisco);
                    psInsertFact.setInt(29, idTempo);
                    psInsertFact.setInt(30, idFaixa);
                    psInsertFact.setInt(31, idColeta);
                    psInsertFact.setInt(32, idMunicipio);
                    psInsertFact.setInt(33, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorD() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where (asc_us = 1 and C_ID_IDAD > 29) OR (lsil=1 and C_ID_IDAD >= 25) and (Year(data_liberacao) = 2012 or Year(data_liberacao) = 2013)", uids);
            String readCitoRecords = "select data_coleta, data_liberacao, C_ID_IDAD, asc_us, lsil, com_atipia, sem_atipia, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);
            String readHistoRecords = "select data_coleta, data_liberacao, c_d_alto_risco, negativa_nic1"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select DN1C,  DP1C2C, DT1C2C, DN2C, DN2CP, DP2CP1HA3CB, DT2CP1HA, DT2CP3CB, DN1HA, "
                    + "DN3CB, DN1HAALTORISCO, DN1HABAIXORISCO, DP1HA3CC, DT1HA3CC, DN3CC, DN2CN, DP2CN3CA, DT2CN3CA, DN3CA, DN3CP, DP3CP1HB4C, DT3CP1HB, DT3CP4C, DN3CN, DN1HB, "
                    + " DN4C, DN1HBALTORISCO, DN1HBBAIXORISCO"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (DN1C,  DP1C2C, DT1C2C, DN2C, DN2CP, DP2CP1HA3CB, DT2CP1HA, DT2CP3CB, "
                    + "DN1HA, DN3CB, DN1HAALTORISCO, DN1HABAIXORISCO, DP1HA3CC, DT1HA3CC, DN3CC, DN2CN, DP2CN3CA, DT2CN3CA, DN3CA, DN3CP, DP3CP1HB4C, DT3CP1HB, DT3CP4C, DN3CN, DN1HB, "
                    + " DN4C, DN1HBALTORISCO, DN1HBBAIXORISCO, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
            String updateFact = "update siscolodw.fatos set DN1C = ?, DP1C2C = ?, DT1C2C = ?, DN2C = ?, DN2CP = ?, DP2CP1HA3CB = ?, DT2CP1HA = ?, DT2CP3CB = ?, DN1HA = ?, DN3CB = ?, "
                    + "DN1HAALTORISCO = ?, DN1HABAIXORISCO = ?, DP1HA3CC = ?, DT1HA3CC = ?, DN3CC = ?, DN2CN = ?, DP2CN3CA = ?, DT2CN3CA = ?, DN3CA = ?, DN3CP = ?, DP3CP1HB4C = ?, DT3CP1HB = ?, DT3CP4C = ?, DN3CN = ?, DN1HB = ?, "
                    + " DN4C = ?, DN1HBALTORISCO = ?, DN1HBBAIXORISCO = ?"
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";

            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                boolean exameHisto1 = false;
                int cn1c = 1;
                int cp1c2c = 0;
                int cn2c = 0;
                int cn2cp = 0;
                int cn3ca = 0;
                int cn3cc = 0;
                int cn3cb = 0;
                int cn1ha = 0;
                int cn1hb = 0;
                int cn3cn = 0;
                int cn3cp = 0;
                int cn4c = 0;
                int cn1haaltorisco = 0;
                int cn1habaixorisco = 0;
                int cn1hbbaixorisco = 0;
                int cn1hbaltorisco = 0;
                int cp1h3c = 0;
                int cp2cp1ha3cb = 0;
                int cn2cn = 0;
                int cp2c3c = 0;
                int cp3c1h = 0;
                int intervaloCito1Cito2 = -1;
                int intervaloCito2Cito3a = -1;
                int intervaloCito2Cito3b = -1;
                int intervaloCito3Cito4 = -1;
                int intervaloCito3Histo1 = -1;
                int intervaloCito2Histo1 = -1;
                int intervaloHisto1Cito3 = -1;
                Date dataLiberacaoCito2 = null;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito2 = null;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int idade = rsCitoRecords.getInt("C_ID_IDAD");
                int ascus = rsCitoRecords.getInt("asc_us");
                int lsil = rsCitoRecords.getInt("lsil");
                LocalDate lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2013) && (((ascus == 1) && (idade > 29)) || ((lsil == 1) && (idade > 24))))) {
                    continue;
                }
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                cp1c2c = 1;
                if (rsCitoRecords.next()) {
                    Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                    dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                    lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                    lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                    if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                        intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                        cn2c = 1;
                        cp1c2c = 0;
                        int comAtipia = rsCitoRecords.getInt("com_atipia");
                        int semAtipia = rsCitoRecords.getInt("sem_atipia");
                        if (comAtipia == 1) {
                            cn2cp = 1;
                            psReadHistoRecords.setInt(1, uid);
                            ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                            cp2cp1ha3cb = 1;
                            while (rsHistoRecords.next()) {
                                Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                                LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                                if (dataExameHisto.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Histo1 = (int) DAYS.between(lcdataLiberacaoCito2, lcdataExameHisto);
                                    cn1ha = 1;
                                    cp2cp1ha3cb = 0;
                                    exameHisto1 = true;
                                    int altoRisco = rsHistoRecords.getInt("c_d_alto_risco");
                                    int baixoRisco = rsHistoRecords.getInt("negativa_nic1");
                                    if (baixoRisco == 1) {
                                        cn1habaixorisco = 1;
                                        cp1h3c = 1;
                                        while (rsCitoRecords.next()) {
                                            Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                            LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                            Date dataLiberacaoHisto1 = rsHistoRecords.getDate("data_liberacao");
                                            LocalDate lcdataLiberacaoHisto1 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoHisto1);
                                            if (dataColetaCito3.compareTo(dataLiberacaoHisto1) >= 0) {
                                                intervaloHisto1Cito3 = (int) DAYS.between(lcdataLiberacaoHisto1, lcdataColetaCito3);
                                                cn3cc = 1;
                                                cp1h3c = 0;
                                                break;
                                            }
                                        }
                                    } else if (altoRisco == 1) {
                                        cn1haaltorisco = 1;
                                    }
                                    break;
                                }

                            }
                            if (!exameHisto1) {
                                if (rsCitoRecords.next()) {
                                    Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                    LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                    if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                        intervaloCito2Cito3b = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                        cn3cb = 1;
                                        cp2cp1ha3cb = 0;
                                    }
                                }
                            }
                        } else if (semAtipia == 1) {
                            cn2cn = 1;
                            cp2c3c = 1;
                            if (rsCitoRecords.next()) {
                                Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                Date dataLiberacaoCito3 = rsCitoRecords.getDate("data_liberacao");
                                LocalDate lcdataLiberacaoCito3 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito3);
                                if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Cito3a = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                    cn3ca = 1;
                                    cp2c3c = 0;
                                    comAtipia = rsCitoRecords.getInt("com_atipia");
                                    semAtipia = rsCitoRecords.getInt("sem_atipia");
                                    if (comAtipia == 1) {
                                        cn3cp = 1;
                                        psReadHistoRecords.setInt(1, uid);
                                        ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                                        cp3c1h = 1;
                                        while (rsHistoRecords.next()) {
                                            Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                                            LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                                            if (dataExameHisto.compareTo(dataLiberacaoCito3) >= 0) {
                                                intervaloCito3Histo1 = (int) DAYS.between(lcdataLiberacaoCito3, lcdataExameHisto);
                                                cn1hb = 1;
                                                cp3c1h = 0;
                                                exameHisto1 = true;
                                                int altoRisco = rsHistoRecords.getInt("c_d_alto_risco");
                                                int baixoRisco = rsHistoRecords.getInt("negativa_nic1");
                                                if (baixoRisco == 1) {
                                                    cn1hbbaixorisco = 1;
                                                } else if (altoRisco == 1) {
                                                    cn1hbaltorisco = 1;
                                                }
                                                break;
                                            }
                                        }
                                        if (!exameHisto1) {
                                            if (rsCitoRecords.next()) {
                                                Date dataColetaCito4 = rsCitoRecords.getDate("data_coleta");
                                                LocalDate lcdataColetaCito4 = IndicadoresLongitudinais.toLocalDate(dataColetaCito4);
                                                if (dataColetaCito4.compareTo(dataLiberacaoCito3) >= 0) {
                                                    intervaloCito3Cito4 = (int) DAYS.between(lcdataLiberacaoCito3, lcdataColetaCito4);
                                                    cn4c = 1;
                                                    cp3c1h = 0;
                                                }
                                            }
                                        }
                                    } else if (semAtipia == 1) {
                                        cn3cn = 1;
                                    }
                                }
                            }

                        }
                    }
                }
                // atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                if (rs.next()) {
                    cn1c = rs.getInt("DN1C") + 1;
                    cp1c2c = rs.getInt("DP1C2C") + cp1c2c;
                    cn2c = rs.getInt("DN2C") + cn2c;
                    cn2cp = rs.getInt("DN2CP") + cn2cp;
                    cp2cp1ha3cb = rs.getInt("DP2CP1HA3CB") + cp2cp1ha3cb;
                    cn1ha = rs.getInt("DN1HA") + cn1ha;
                    cn3cb = rs.getInt("DN3CB") + cn3cb;
                    cn1haaltorisco = rs.getInt("DN1HAALTORISCO") + cn1haaltorisco;
                    cn1habaixorisco = rs.getInt("DN1HABAIXORISCO") + cn1habaixorisco;
                    cp1h3c = rs.getInt("DP1HA3CC") + cp1h3c;
                    cn3cc = rs.getInt("DN3CC") + cn3cc;
                    cn2cn = rs.getInt("DN2CN") + cn2cn;
                    cp2c3c = rs.getInt("DP2CN3CA") + cp2c3c;
                    cn3ca = rs.getInt("DN3CA") + cn3ca;
                    cn3cp = rs.getInt("DN3CP") + cn3cp;
                    cp3c1h = rs.getInt("DP3CP1HB4C") + cp3c1h;
                    cn3cn = rs.getInt("DN3CN") + cn3cn;
                    cn1hb = rs.getInt("DN1HB") + cn1hb;
                    cn1hbaltorisco = rs.getInt("DN1HBALTORISCO") + cn1hbaltorisco;
                    cn1hbbaixorisco = rs.getInt("DN1HBBAIXORISCO") + cn1hbbaixorisco;
                    cn4c = rs.getInt("DN4C") + cn4c;
                    int intervaloAntigo = rs.getInt("DT1HA3CC");
                    if (intervaloHisto1Cito3 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHisto1Cito3 = intervaloAntigo + intervaloHisto1Cito3;
                        }
                    } else {
                        intervaloHisto1Cito3 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("DT2CP3CB");
                    if (intervaloCito2Cito3b != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3b = intervaloAntigo + intervaloCito2Cito3b;
                        }
                    } else {
                        intervaloCito2Cito3b = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("DT2CN3CA");
                    if (intervaloCito2Cito3a != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3a = intervaloAntigo + intervaloCito2Cito3a;
                        }
                    } else {
                        intervaloCito2Cito3a = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("DT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("DT3CP4C");
                    if (intervaloCito3Cito4 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito3Cito4 = intervaloAntigo + intervaloCito3Cito4;
                        }
                    } else {
                        intervaloCito3Cito4 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("DT2CP1HA");
                    if (intervaloCito2Histo1 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Histo1 = intervaloAntigo + intervaloCito2Histo1;
                        }
                    } else {
                        intervaloCito2Histo1 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("DT3CP1HB");
                    if (intervaloCito3Histo1 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito3Histo1 = intervaloAntigo + intervaloCito3Histo1;
                        }
                    } else {
                        intervaloCito3Histo1 = intervaloAntigo;
                    }
                    psUpdateFact.setInt(1, cn1c);
                    psUpdateFact.setInt(2, cp1c2c);
                    psUpdateFact.setInt(3, intervaloCito1Cito2);
                    psUpdateFact.setInt(4, cn2c);
                    psUpdateFact.setInt(5, cn2cp);
                    psUpdateFact.setInt(6, cp2cp1ha3cb);
                    psUpdateFact.setInt(7, intervaloCito2Histo1);
                    psUpdateFact.setInt(8, intervaloCito2Cito3b);
                    psUpdateFact.setInt(9, cn1ha);
                    psUpdateFact.setInt(10, cn3cb);
                    psUpdateFact.setInt(11, cn1haaltorisco);
                    psUpdateFact.setInt(12, cn1habaixorisco);
                    psUpdateFact.setInt(13, cp1h3c);
                    psUpdateFact.setInt(14, intervaloHisto1Cito3);
                    psUpdateFact.setInt(15, cn3cc);
                    psUpdateFact.setInt(16, cn2cn);
                    psUpdateFact.setInt(17, cp2c3c);
                    psUpdateFact.setInt(18, intervaloCito2Cito3a);
                    psUpdateFact.setInt(19, cn3ca);
                    psUpdateFact.setInt(20, cn3cp);
                    psUpdateFact.setInt(21, cp3c1h);
                    psUpdateFact.setInt(22, intervaloCito3Histo1);
                    psUpdateFact.setInt(23, intervaloCito3Cito4);
                    psUpdateFact.setInt(24, cn3cn);
                    psUpdateFact.setInt(25, cn1hb);
                    psUpdateFact.setInt(26, cn4c);
                    psUpdateFact.setInt(27, cn1hbaltorisco);
                    psUpdateFact.setInt(28, cn1hbbaixorisco);
                    psUpdateFact.setInt(29, idTempo);
                    psUpdateFact.setInt(30, idFaixa);
                    psUpdateFact.setInt(31, idColeta);
                    psUpdateFact.setInt(32, idMunicipio);
                    psUpdateFact.setInt(33, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, cn1c);
                    psInsertFact.setInt(2, cp1c2c);
                    psInsertFact.setInt(3, intervaloCito1Cito2);
                    psInsertFact.setInt(4, cn2c);
                    psInsertFact.setInt(5, cn2cp);
                    psInsertFact.setInt(6, cp2cp1ha3cb);
                    psInsertFact.setInt(7, intervaloCito2Histo1);
                    psInsertFact.setInt(8, intervaloCito2Cito3b);
                    psInsertFact.setInt(9, cn1ha);
                    psInsertFact.setInt(10, cn3cb);
                    psInsertFact.setInt(11, cn1haaltorisco);
                    psInsertFact.setInt(12, cn1habaixorisco);
                    psInsertFact.setInt(13, cp1h3c);
                    psInsertFact.setInt(14, intervaloHisto1Cito3);
                    psInsertFact.setInt(15, cn3cc);
                    psInsertFact.setInt(16, cn2cn);
                    psInsertFact.setInt(17, cp2c3c);
                    psInsertFact.setInt(18, intervaloCito2Cito3a);
                    psInsertFact.setInt(19, cn3ca);
                    psInsertFact.setInt(20, cn3cp);
                    psInsertFact.setInt(21, cp3c1h);
                    psInsertFact.setInt(22, intervaloCito3Histo1);
                    psInsertFact.setInt(23, intervaloCito3Cito4);
                    psInsertFact.setInt(24, cn3cn);
                    psInsertFact.setInt(25, cn1hb);
                    psInsertFact.setInt(26, cn4c);
                    psInsertFact.setInt(27, cn1hbaltorisco);
                    psInsertFact.setInt(28, cn1hbbaixorisco);
                    psInsertFact.setInt(29, idTempo);
                    psInsertFact.setInt(30, idFaixa);
                    psInsertFact.setInt(31, idColeta);
                    psInsertFact.setInt(32, idMunicipio);
                    psInsertFact.setInt(33, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

    public void geraIndicadorH() {
        try {
            con = getDatabaseConnection(props);
            int count = 0;
            uids = new HashSet<>();
            getIds("Select uid_ from siscolo.cito_seguimento where aoi = 1  and Year(data_liberacao) >= 2012 and Year(data_liberacao) < 2015", uids);
            /*            getDimensionIds("select id from siscolodw.tempo", idsTempo);
             getDimensionIds("select cnes from siscolodw.laboratorio", idsLaboratorio);
             getDimensionIds("select id from siscolodw.u_coleta", idsColeta);
             getDimensionIds("select codigo from siscolodw.municipio_residencia", idsMunicipio);
             */
            String readCitoRecords = "select data_coleta, data_liberacao, aoi, h_baixo_risco, h_alto_risco, faixa_etaria, municipio_residencia, id_tempo, C_CNES, id_u_coleta from siscolo.cito_seguimento where uid_ = ? order by data_liberacao";
            PreparedStatement psReadCitoRecords = con.prepareStatement(readCitoRecords);

            String readHistoRecords = "select data_coleta, data_liberacao, negativa_nic1, h_aden_can_nic"
                    + " from siscolo.histo_seguimento histo, siscolo.histocitopares_uids hc "
                    + " where histo.uid_ = hc.uidHisto_  and hc.uidCito = ? order by data_coleta";
            PreparedStatement psReadHistoRecords = con.prepareStatement(readHistoRecords);
            String fetchFact = "select HN1C, HP1C2C1H, HT1C2C, HT1C1H, HN2C, HN1H, HNNicAdenoCancer, HNNic1Negativo, HN2Cb, HP1H2Cb, HT1H2Cb, HNbaixoRisco, HNaltoRisco, "
                    + "HNaoi, HP2C3C1H, HN3C, HT2C3C, HN1Hb, HT2C1Hb"
                    + " from siscolodw.fatos where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            String insertFact = "insert into siscolodw.fatos (HN1C, HP1C2C1H, HT1C2C, HT1C1H, HN2C, HN1H, HNNicAdenoCancer, HNNic1Negativo, HN2Cb, HP1H2Cb, HT1H2Cb, HNbaixoRisco, HNaltoRisco, "
                    + "HNaoi, HP2C3C1H, HN3C, HT2C3C, HN1Hb, HT2C1Hb, "
                    + "id_tempo, faixa_etaria, id_u_coleta, municipio_residencia, C_CNES) values (? , ?, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ? , ?, ?, ?, ?, ?, ?, ? , ?, ?)";
            String updateFact = "update siscolodw.fatos set HN1C = ?, HP1C2C1H = ?, HT1C2C = ?, HT1C1H = ?, HN2C = ?, HN1H = ?, HNNicAdenoCancer = ?, HNNic1Negativo = ?, HN2Cb = ?, HP1H2Cb = ?,"
                    + " HT1H2Cb = ?, HNbaixoRisco = ?, HNaltoRisco = ?, HNaoi = ?, HP2C3C1H = ?, HN3C = ?, HT2C3C = ?, HN1Hb = ?, HT2C1Hb = ? "
                    + " where id_tempo = ? AND faixa_etaria= ? AND id_u_coleta =  ? "
                    + "AND municipio_residencia = ? AND C_CNES = ?";
            PreparedStatement psFetchFact = con.prepareStatement(fetchFact);
            PreparedStatement psInsertFact = con.prepareStatement(insertFact);
            PreparedStatement psUpdateFact = con.prepareStatement(updateFact);
            con.setAutoCommit(false);
            for (Integer uid : uids) {
                boolean exameHisto = false;
                boolean ano2014 = false;
                boolean temOutroExame = false;
                int hnic1 = 0;
                int hn1h = 0;
                int hn1c = 1;
                int hp1c2c1h = 0;
                int hn2c = 0;
                int hn2cb = 0;
                int hn3c = 0;
                int hp1h2cb = 0;
                int hncancers = 0;
                int hnBaixoRisco = 0;
                int hnAltoRisco = 0;
                int hnaoi = 0;
                int hp2c3c1h = 0;
                int hn1hb = 0;
                int intervaloCito1Cito2 = -1;
                int intervaloCito2Cito3 = -1;
                int intervaloHisto1Cito2 = -1;
                int intervaloCito1Histo1 = -1;
                int intervaloCito2Histo1 = -1;
                Date dataLiberacaoCito2 = null;
                boolean segundoCito = false;
                psReadCitoRecords.setInt(1, uid);
                ResultSet rsCitoRecords = psReadCitoRecords.executeQuery();
                rsCitoRecords.next();
                int idTempo = rsCitoRecords.getInt("id_tempo");
                int idFaixa = rsCitoRecords.getInt("faixa_etaria");
                int idColeta = rsCitoRecords.getInt("id_u_coleta");
                int idMunicipio = rsCitoRecords.getInt("municipio_residencia");
                int idLaboratorio = rsCitoRecords.getInt("C_CNES");
                psFetchFact.setInt(1, idTempo);
                psFetchFact.setInt(2, idFaixa);
                psFetchFact.setInt(3, idColeta);
                psFetchFact.setInt(4, idMunicipio);
                psFetchFact.setInt(5, idLaboratorio);
                Date dataLiberacaoCito;
                LocalDate lcdataLiberacaoCito, lcdataLiberacaoCito2 = null;
                LocalDate lcdataColetaCito2;
                dataLiberacaoCito = rsCitoRecords.getDate("data_liberacao");
                int aoi = rsCitoRecords.getInt("aoi");
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                if (!((lcdataLiberacaoCito.getYear() >= 2012) && (lcdataLiberacaoCito.getYear() <= 2014) && (aoi == 1))) {
                    continue;
                }
                if (lcdataLiberacaoCito.getYear() == 2014) {
                    ano2014 = true;
                }
                lcdataLiberacaoCito = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito);
                // verifica se a mulher realizou exame histologico
                psReadHistoRecords.setInt(1, uid);
                ResultSet rsHistoRecords = psReadHistoRecords.executeQuery();
                while (rsHistoRecords.next()) {
                    Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                    Date dataLiberacaoHisto = rsHistoRecords.getDate("data_liberacao");
                    // compara datas
                    LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                    LocalDate lcdataLiberacaoHisto = IndicadoresLongitudinais.toLocalDate(dataLiberacaoHisto);
                    int intervalo = (int) DAYS.between(lcdataLiberacaoCito, lcdataExameHisto);
                    if (dataExameHisto.compareTo(dataLiberacaoCito) >= 0) {
                        temOutroExame = true;
                        intervaloCito1Histo1 = intervalo;
                        hncancers = rsHistoRecords.getInt("h_aden_can_nic");
                        hnic1 = rsHistoRecords.getInt("negativa_nic1");
                        if (hnic1 == 1) {
                            hp1h2cb = 1;
                            while (rsCitoRecords.next()) {
                                Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                                lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                                if (dataColetaCito2.compareTo(dataLiberacaoHisto) >= 0) {
                                    intervaloHisto1Cito2 = (int) DAYS.between(lcdataLiberacaoHisto, lcdataColetaCito2);
                                    hp1h2cb = 0;
                                    hn2cb = 1;
                                    break;
                                }
                            }
                        }
                        hn1h++;
                        exameHisto = true;
                        rsHistoRecords.close();
                        break;
                    }
                }
                // segundo cito
                if (!exameHisto) {
                    if (rsCitoRecords.next()) {
                        Date dataColetaCito2 = rsCitoRecords.getDate("data_coleta");
                        dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                        lcdataColetaCito2 = IndicadoresLongitudinais.toLocalDate(dataColetaCito2);
                        lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                        if (dataColetaCito2.compareTo(dataLiberacaoCito) >= 0) {
                            intervaloCito1Cito2 = (int) DAYS.between(lcdataLiberacaoCito, lcdataColetaCito2);
                            segundoCito = true;
                            temOutroExame = true;
                        }
                    }
                    if (segundoCito) {
                        hn2c = 1;
                        hnBaixoRisco = rsCitoRecords.getInt("h_baixo_risco");
                        hnAltoRisco = rsCitoRecords.getInt("h_alto_risco");
                        aoi = rsCitoRecords.getInt("aoi");
                        if (aoi == 1) {
                            hnaoi = 1;
                            hp2c3c1h = 1;
                            boolean exameHisto2 = false;
                            dataLiberacaoCito2 = rsCitoRecords.getDate("data_liberacao");
                            lcdataLiberacaoCito2 = IndicadoresLongitudinais.toLocalDate(dataLiberacaoCito2);
                            psReadHistoRecords.setInt(1, uid);
                            while (rsHistoRecords.next()) {
                                Date dataExameHisto = rsHistoRecords.getDate("data_coleta");
                                LocalDate lcdataExameHisto = IndicadoresLongitudinais.toLocalDate(dataExameHisto);
                                int intervalo = (int) DAYS.between(lcdataLiberacaoCito2, lcdataExameHisto);
                                if (dataExameHisto.compareTo(dataLiberacaoCito2) >= 0) {
                                    intervaloCito2Histo1 = intervalo;
                                    hn1hb = 1;
                                    exameHisto2 = true;
                                    rsHistoRecords.close();
                                    hp2c3c1h = 0;
                                    break;
                                }
                            }
                            if (!exameHisto2) {
                                if (rsCitoRecords.next()) {
                                    Date dataColetaCito3 = rsCitoRecords.getDate("data_coleta");
                                    LocalDate lcdataColetaCito3 = IndicadoresLongitudinais.toLocalDate(dataColetaCito3);
                                    if (dataColetaCito3.compareTo(dataLiberacaoCito2) >= 0) {
                                        intervaloCito2Cito3 = (int) DAYS.between(lcdataLiberacaoCito2, lcdataColetaCito3);
                                        hn3c = 1;
                                        hp2c3c1h = 0;
                                    }
                                }
                            }

                        }
                    }
                }
                if (ano2014 && !temOutroExame) {
                    continue;
                }
// atualiza tabela de fatos
                ResultSet rs = psFetchFact.executeQuery();
                hp1c2c1h = hn1c - Math.max(hn1h, hn2c);
                if (rs.next()) {
                    hn1c = rs.getInt("HN1C") + 1;
                    hp1c2c1h = rs.getInt("HP1C2C1H") + hp1c2c1h;
                    hn1h = rs.getInt("HN1H") + hn1h;
                    int intervaloAntigo = rs.getInt("HT1H2Cb");
                    if (intervaloHisto1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloHisto1Cito2 = intervaloAntigo + intervaloHisto1Cito2;
                        }
                    } else {
                        intervaloHisto1Cito2 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("HT1C1H");
                    if (intervaloCito1Histo1 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Histo1 = intervaloAntigo + intervaloCito1Histo1;
                        }
                    } else {
                        intervaloCito1Histo1 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("HT2C1Hb");
                    if (intervaloCito2Histo1 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Histo1 = intervaloAntigo + intervaloCito2Histo1;
                        }
                    } else {
                        intervaloCito2Histo1 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("HT2C3C");
                    if (intervaloCito2Cito3 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito2Cito3 = intervaloAntigo + intervaloCito2Cito3;
                        }
                    } else {
                        intervaloCito2Cito3 = intervaloAntigo;
                    }
                    intervaloAntigo = rs.getInt("HT1C2C");
                    if (intervaloCito1Cito2 != -1) {
                        if (intervaloAntigo != -1) {
                            intervaloCito1Cito2 = intervaloAntigo + intervaloCito1Cito2;
                        }
                    } else {
                        intervaloCito1Cito2 = intervaloAntigo;
                    }
                    hncancers = rs.getInt("HNNicAdenoCancer") + hncancers;
                    hnic1 = rs.getInt("HNNic1Negativo") + hnic1;
                    hn2c = hn2c + rs.getInt("HN2C");
                    hnaoi = rs.getInt("HNaoi") + hnaoi;
                    hnBaixoRisco = rs.getInt("HNbaixoRisco") + hnBaixoRisco;
                    hnAltoRisco = rs.getInt("HNaltoRisco") + hnAltoRisco;
                    hn3c = rs.getInt("HN3C") + hn3c;
                    hn2cb = rs.getInt("HN2CB") + hn2cb;
                    hp1h2cb = rs.getInt("HP1H2Cb") + hp1h2cb;
                    hp2c3c1h = rs.getInt("HP2C3C1H") + hp2c3c1h;
                    hn1hb = rs.getInt("HN1Hb") + hn1hb;
                    psUpdateFact.setInt(1, hn1c);
                    psUpdateFact.setInt(2, hp1c2c1h);
                    psUpdateFact.setInt(3, intervaloCito1Cito2);
                    psUpdateFact.setInt(4, intervaloCito1Histo1);
                    psUpdateFact.setInt(5, hn2c);
                    psUpdateFact.setInt(6, hn1h);
                    psUpdateFact.setInt(7, hncancers);
                    psUpdateFact.setInt(8, hnic1);
                    psUpdateFact.setInt(9, hn2cb);
                    psUpdateFact.setInt(10, hp1h2cb);
                    psUpdateFact.setInt(11, intervaloHisto1Cito2);
                    psUpdateFact.setInt(12, hnBaixoRisco);
                    psUpdateFact.setInt(13, hnAltoRisco);
                    psUpdateFact.setInt(14, hnaoi);
                    psUpdateFact.setInt(15, hp2c3c1h);
                    psUpdateFact.setInt(16, hn3c);
                    psUpdateFact.setInt(17, intervaloCito2Cito3);
                    psUpdateFact.setInt(18, hn1hb);
                    psUpdateFact.setInt(19, intervaloCito2Histo1);
                    psUpdateFact.setInt(20, idTempo);
                    psUpdateFact.setInt(21, idFaixa);
                    psUpdateFact.setInt(22, idColeta);
                    psUpdateFact.setInt(23, idMunicipio);
                    psUpdateFact.setInt(24, idLaboratorio);
                    psUpdateFact.executeUpdate();
                } else {
                    psInsertFact.setInt(1, hn1c);
                    psInsertFact.setInt(2, hp1c2c1h);
                    psInsertFact.setInt(3, intervaloCito1Cito2);
                    psInsertFact.setInt(4, intervaloCito1Histo1);
                    psInsertFact.setInt(5, hn2c);
                    psInsertFact.setInt(6, hn1h);
                    psInsertFact.setInt(7, hncancers);
                    psInsertFact.setInt(8, hnic1);
                    psInsertFact.setInt(9, hn2cb);
                    psInsertFact.setInt(10, hp1h2cb);
                    psInsertFact.setInt(11, intervaloHisto1Cito2);
                    psInsertFact.setInt(12, hnBaixoRisco);
                    psInsertFact.setInt(13, hnAltoRisco);
                    psInsertFact.setInt(14, hnaoi);
                    psInsertFact.setInt(15, hp2c3c1h);
                    psInsertFact.setInt(16, hn3c);
                    psInsertFact.setInt(17, intervaloCito2Cito3);
                    psInsertFact.setInt(18, hn1hb);
                    psInsertFact.setInt(19, intervaloCito2Histo1);
                    psInsertFact.setInt(20, idTempo);
                    psInsertFact.setInt(21, idFaixa);
                    psInsertFact.setInt(22, idColeta);
                    psInsertFact.setInt(23, idMunicipio);
                    psInsertFact.setInt(24, idLaboratorio);
                    psInsertFact.executeUpdate();
                }
                if ((count++ % 10000) == 0) {
                    con.commit();
                }
            }
            con.commit();
        } catch (SQLException ex) {
            System.out.println(ex.getMessage());
        } finally {
            try {
                con.close();
            } catch (SQLException ex) {
            }
        }
    }

}
